// HTMLView.cpp : implementation of the CHTMLTestView class
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"

#include "HTMLView.h"

HRESULT CHTMLView::get_Control(IUnknown** ppControl)
{
	if(m_hWnd != NULL)
	{
		return CAxWindow::QueryControl(ppControl);
	}
	return NULL;
}

LRESULT CHTMLView::OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	LRESULT nResult = DefWindowProc(uMsg, wParam, lParam);
	bHandled = TRUE;
	if(m_hWnd != NULL)
		CAxWindow::QueryControl(&m_pBrowser);
	return nResult;
}

LRESULT CHTMLView::OnDestroy(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	bHandled = FALSE;
	return 0;
}

void CHTMLView::Go(LPCSTR lpszAddress)
{
	if (lpszAddress)
	{
		if ((!m_pBrowser) && (m_hWnd))
			CAxWindow::QueryControl(&m_pBrowser);
		if (!m_pBrowser) return;
		VARIANT v; v.lVal = navNoHistory;
		_bstr_t baddress = lpszAddress;
		m_pBrowser->Navigate(baddress,&v,NULL,NULL,NULL);
	}
}

BOOL CHTMLView::PreTranslateMessage(MSG* pMsg)
{
	if((pMsg->message < WM_KEYFIRST || pMsg->message > WM_KEYLAST) &&
	   (pMsg->message < WM_MOUSEFIRST || pMsg->message > WM_MOUSELAST))
		return FALSE;

	// give HTML page a chance to translate this message
	return (BOOL)SendMessage(WM_FORWARDMSG, 0, (LPARAM)pMsg);
}

void CHTMLView::ReloadData(int iID)
{
	CString sFile = "c:\\temp.htm";
	CString sOutText = "<html><body topmargin='0' leftmargin='0' rightmargin='0' bottommargin='0'>";
	sOutText += "<table border='0' width='100%' bgcolor='#C0C0C0'><tr><td>";
	sOutText += "<b><font face='Verdana' size='2'></font></b></td></tr></table>";
	sOutText += "<table border='1' width='100%' cellspacing='0' cellpadding='0'>";
	DeleteFile(sFile);
	HANDLE hfile = CreateFile(sFile,GENERIC_WRITE,FILE_SHARE_WRITE,NULL,CREATE_NEW,FILE_ATTRIBUTE_NORMAL,NULL);
	if (iID<0)
		sOutText += "</table></body></html>";
	else
	{
		try
		{
			if (m_pRec == NULL)
				CoCreateInstance(__uuidof(Recordset), NULL, CLSCTX_ALL, __uuidof(_Recordset), (void**)&m_pRec);
			else
				m_pRec->Close();
			m_pRec->CursorLocation = adUseClient;
			_bstr_t query = "SELECT Prices.id, Providers.Name AS ProviderName, Prices.DEVELOPER, Prices.GROUPNAME, Prices.CODE, Prices.NAME, Prices.ORIGINAL, ";
			query += " Prices.MODEL, Prices.PRICE, Prices.PRICE2, Prices.PRICE3, Prices.PRICE4, Prices.CURRENCY, Prices.EXIST, Prices.CreateDate, Providers.LASTFILE, "; 
			query += " Prices.ProviderId, Prices.Original, Providers.PrimaryPrice AS PrimaryPrice  ";
			query += " FROM Prices INNER JOIN Providers ON Prices.ProviderId = Providers.id";
			query += " WHERE  Prices.id = ";
			_variant_t vid(iID);
			vid.ChangeType(VT_BSTR);
			query += vid.bstrVal;
			m_pRec->Open(query, _variant_t((IDispatch *)m_pCon,true), adOpenForwardOnly, adLockOptimistic, adCmdUnspecified);
			if (m_pRec->RecordCount<=0) return;
			m_pRec->MoveFirst();
			VARIANT vVal;
			int iPrimary = 1;
			m_pRec->Fields->GetItem("PrimaryPrice")->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			{
				_variant_t vv = _variant_t(vVal);
				vv.ChangeType(VT_I4);
				iPrimary = (int)vv.lVal;
			}
			sOutText += "<tr><td width='200'><p align='right'><b><font face='Verdana' color='#000080' size='2'> &nbsp;</font></b></td>";
			sOutText += "<td><b><font face='Verdana' size='2'>&nbsp;";
			m_pRec->Fields->GetItem("ProviderName")->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			{
				_variant_t vv = _variant_t(vVal);
				vv.ChangeType(VT_BSTR);
				sOutText += (LPCSTR)_bstr_t(vv.bstrVal);
			}
			sOutText += "</font></b></td></tr>";
			sOutText += "<tr><td width='200'><p align='right'><b><font face='Verdana' color='#000080' size='2'> &nbsp;</font></b></td>";
			sOutText += "<td><b><font face='Verdana' size='2'>&nbsp;";
			m_pRec->Fields->GetItem("DEVELOPER")->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			{
				_variant_t vv = _variant_t(vVal);
				vv.ChangeType(VT_BSTR);
				sOutText += (LPCSTR)_bstr_t(vv.bstrVal);
			}
			sOutText += "</font></b></td></tr>";
			sOutText += "<tr><td width='200'><p align='right'><b><font face='Verdana' color='#000080' size='2'> &nbsp;</font></b></td>";
			sOutText += "<td><b><font face='Verdana' size='2'>&nbsp;";
			m_pRec->Fields->GetItem("GROUPNAME")->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			{
				_variant_t vv = _variant_t(vVal);
				vv.ChangeType(VT_BSTR);
				sOutText += (LPCSTR)_bstr_t(vv.bstrVal);
			}
			sOutText += "</font></b></td></tr>";
			sOutText += "<tr><td width='200'><p align='right'><b><font face='Verdana' color='#000080' size='2'>  &nbsp;</font></b></td>";
			sOutText += "<td><b><font face='Verdana' size='2'>&nbsp;";
			m_pRec->Fields->GetItem("CODE")->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			{
				_variant_t vv = _variant_t(vVal);
				vv.ChangeType(VT_BSTR);
				sOutText += (LPCSTR)_bstr_t(vv.bstrVal);
			}
			sOutText += "</font></b></td></tr>";
			sOutText += "<tr><td width='200'><p align='right'><b><font face='Verdana' color='#000080' size='2'>  &nbsp;</font></b></td>";
			sOutText += "<td><b><font face='Verdana' size='2'>&nbsp;";
			m_pRec->Fields->GetItem("ORIGINAL")->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			{
				_variant_t vv = _variant_t(vVal);
				vv.ChangeType(VT_BSTR);
				sOutText += (LPCSTR)_bstr_t(vv.bstrVal);
			}
			sOutText += "</font></b></td></tr>";
			sOutText += "<tr><td width='200'><p align='right'><b><font face='Verdana' color='#000080' size='2'> &nbsp;</font></b></td>";
			sOutText += "<td><b><font face='Verdana' size='2'>&nbsp;";
			m_pRec->Fields->GetItem("Name")->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			{
				_variant_t vv = _variant_t(vVal);
				vv.ChangeType(VT_BSTR);
				sOutText += (LPCSTR)_bstr_t(vv.bstrVal);
			}
			sOutText += "</font></b></td></tr>";
			sOutText += "<tr><td width='200'><p align='right'><b><font face='Verdana' color='#000080' size='2'> &nbsp;</font></b></td>";
			sOutText += "<td><b><font face='Verdana' size='2'>&nbsp;";
			m_pRec->Fields->GetItem("MODEL")->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			{
				_variant_t vv = _variant_t(vVal);
				vv.ChangeType(VT_BSTR);
				sOutText += (LPCSTR)_bstr_t(vv.bstrVal);
			}
			sOutText += "</font></b></td></tr>";
			sOutText += "<tr><td"; 
			if (iPrimary==1)
				sOutText += " bgcolor='#FFFF66'";
			sOutText += " width='200'><p align='right'><b><font face='Verdana' color='#000080' size='2'> &nbsp;</font></b></td>";
			sOutText += "<td";
			if (iPrimary==1)
				sOutText += " bgcolor='#FFFF66'";
			sOutText += "><b><font face='Verdana' size='2'>&nbsp;";
			m_pRec->Fields->GetItem("Price")->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			{
				_variant_t vv = _variant_t(vVal);
				vv.ChangeType(VT_BSTR);
				sOutText += (LPCSTR)_bstr_t(vv.bstrVal);
			}
			sOutText += "</font></b></td></tr>";
			sOutText += "<tr><td"; 
			if (iPrimary==2)
				sOutText += " bgcolor='#FFFF66'";
			sOutText += " width='200'><p align='right'><b><font face='Verdana' color='#000080' size='2'> 2 &nbsp;</font></b></td>";
			sOutText += "<td";
			if (iPrimary==2)
				sOutText += " bgcolor='#FFFF66'";
			sOutText += "><b><font face='Verdana' size='2'>&nbsp;";
			m_pRec->Fields->GetItem("Price2")->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			{
				_variant_t vv = _variant_t(vVal);
				vv.ChangeType(VT_BSTR);
				sOutText += (LPCSTR)_bstr_t(vv.bstrVal);
			}
			sOutText += "</font></b></td></tr>";
			sOutText += "<tr><td"; 
			if (iPrimary==3)
				sOutText += " bgcolor='#FFFF66'";
			sOutText += " width='200'><p align='right'><b><font face='Verdana' color='#000080' size='2'> 3 &nbsp;</font></b></td>";
			sOutText += "<td";
			if (iPrimary==3)
				sOutText += " bgcolor='#FFFF66'";
			sOutText += "><b><font face='Verdana' size='2'>&nbsp;";
			m_pRec->Fields->GetItem("Price3")->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			{
				_variant_t vv = _variant_t(vVal);
				vv.ChangeType(VT_BSTR);
				sOutText += (LPCSTR)_bstr_t(vv.bstrVal);
			}
			sOutText += "</font></b></td></tr>";
			sOutText += "<tr><td"; 
			if (iPrimary==4)
				sOutText += " bgcolor='#FFFF66'";
			sOutText += " width='200'><p align='right'><b><font face='Verdana' color='#000080' size='2'> 4 &nbsp;</font></b></td>";
			sOutText += "<td";
			if (iPrimary==4)
				sOutText += " bgcolor='#FFFF66'";
			sOutText += "><b><font face='Verdana' size='2'>&nbsp;";
			m_pRec->Fields->GetItem("Price4")->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			{
				_variant_t vv = _variant_t(vVal);
				vv.ChangeType(VT_BSTR);
				sOutText += (LPCSTR)_bstr_t(vv.bstrVal);
			}

			sOutText += "</font></b></td></tr>";
			sOutText += "<tr><td width='200'><p align='right'><b><font face='Verdana' color='#000080' size='2'> &nbsp;</font></b></td>";
			sOutText += "<td><b><font face='Verdana' size='2'>&nbsp;";
			m_pRec->Fields->GetItem("CURRENCY")->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			{
				_variant_t vv = _variant_t(vVal);
				vv.ChangeType(VT_BSTR);
				sOutText += (LPCSTR)_bstr_t(vv.bstrVal);
			}

			sOutText += "</font></b></td></tr>";
			sOutText += "<tr><td width='200'><p align='right'><b><font face='Verdana' color='#000080' size='2'> &nbsp;</font></b></td>";
			sOutText += "<td><b><font face='Verdana' size='2'>&nbsp;";
			m_pRec->Fields->GetItem("EXIST")->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			{
				_variant_t vv = _variant_t(vVal);
				vv.ChangeType(VT_BSTR);
				sOutText += (LPCSTR)_bstr_t(vv.bstrVal);
			}

			sOutText += "</font></b></td></tr>";
			sOutText += "<tr><td width='200'><p align='right'><b><font face='Verdana' color='#000080' size='2'>  &nbsp;</font></b></td>";
			sOutText += "<td><b><font face='Verdana' size='2'>&nbsp;";
			m_pRec->Fields->GetItem("CREATEDATE")->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			{
				_variant_t vv = _variant_t(vVal);
				vv.ChangeType(VT_BSTR);
				sOutText += (LPCSTR)_bstr_t(vv.bstrVal);
			}

			sOutText += "</font></b></td></tr>";
			sOutText += "<tr><td width='200'><p align='right'><b><font face='Verdana' color='#000080' size='2'>  &nbsp;</font></b></td>";
			sOutText += "<td><b><font face='Verdana' size='2'>&nbsp;";
			m_pRec->Fields->GetItem("LASTFILE")->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			{
				_variant_t vv = _variant_t(vVal);
				vv.ChangeType(VT_BSTR);
				sOutText += (LPCSTR)_bstr_t(vv.bstrVal);
			}

//
			sOutText += "</font></b></td></tr>";
			sOutText += "<tr><td width='200'><p align='right'><b><font face='Verdana' color='#000080' size='2'> &nbsp;</font></b></td>";
			sOutText += "<td><b><font face='Verdana' size='2'>&nbsp;";
			sOutText += " ";
			sOutText += "</font></b></td></tr>";
		}
		catch( _com_error &e)
		{
			MessageBox((LPCTSTR)e.Description(),(LPCTSTR)e.Source());
			m_pRec.Release();
			return;
		}
	}
	DWORD dwbw;
	WriteFile(hfile, sOutText, sOutText.GetLength(), &dwbw, NULL);
	CloseHandle(hfile);
	Go(sFile);
}
