#include "StdAfx.h"
#include ".\importfromexcel.h"

using namespace Excel;

CImportFromExcel::CImportFromExcel(void)
{
	m_bSave = TRUE;
	m_iID = -1;
	m_sFileName = "";
	m_pCon = NULL;
	m_pRec = NULL;
	m_pRecPrice = NULL;

	m_iLISTNUM = 1;
	m_iROWNUM = 1;
	m_iDEVELOPERCOL = -1;
	//m_sDEVELOPERDEF;
	m_iGROUPCOL = -1;
	//m_sGROUPDEF;
	m_iCODECOL = -1;
	m_iCODECOL2 = -1;
	m_iCODECOL3 = -1;
	m_iCODECOL4 = -1;
	//m_sCODEDEF;
	m_iNAMECOL = -1;
	//m_sNAMEDEF;
	m_iMODELCOL = -1;
	//m_sMODELDEF;
	m_iPRICECOL = -1;
	m_iPRICE2COL = -1;
	m_iPRICE3COL = -1;
	m_iPRICE4COL = -1;

	m_iPERCENT2 = -1;
	m_iPERCENT3 = -1;
	m_iPERCENT4 = -1;

	m_iORIGINALCOL = -1;
	m_iCURRENCYCOL = -1;
	m_sCURRENCYDEF = "EUR"; 
	m_iEXISTCOL = -1;
	//m_EXISTDEF;
	m_bStarted = FALSE;
	InitializeCriticalSection(&g_cs);

	m_sAction = "";
	m_lCurrentRows = 0;
	m_lTime = GetTickCount();

	m_hExcelThread = NULL;
}

UINT WINAPI CImportFromExcel::ExcelThreadProc(void* pvParam)
{
	CImportFromExcel* pThis = reinterpret_cast<CImportFromExcel*>( pvParam );
	_ASSERTE( pThis != NULL );
	pThis->m_bStarted = TRUE;
	pThis->OpenRecordsets();
	pThis->Import();
	return 1L;
}

CImportFromExcel::~CImportFromExcel(void)
{
	if (IsWindow(m_prDlg.m_hWnd))
		m_prDlg.DestroyWindow();
	DeleteCriticalSection(&g_cs);
}

void CImportFromExcel::UpdateDialog()
{
	EnterCriticalSection(&g_cs);
	if (!m_bStarted)
	{
		LeaveCriticalSection(&g_cs);
		if (IsWindow(m_prDlg))
			::SendMessage(m_prDlg.m_hWnd, WM_CLOSE, 0, 0);
		return;
	}
	if (!IsWindow(m_prDlg))
	{
		m_bStarted = FALSE;
		LeaveCriticalSection(&g_cs);
		return;
	}
	m_bStarted = m_prDlg.m_bStarted;
	m_prDlg.m_sAction = m_sAction;
	_variant_t v(m_lCurrentRows);
	v.ChangeType(VT_BSTR);
	CString s = ": "; s += (LPCSTR)_bstr_t(v.bstrVal);
	m_prDlg.m_sStatus = s;
	long l = GetTickCount() - m_lTime;
	long ls = 0;
	long lm = 0;
	long lh = 0;
	s = "0";
	if (l>0)
	{
		ls = (long)l/1000;
		if (ls>=60)
		{
			lh = ls /3600;
			lm = ls - lh*3600;
			lm = lm/60;
			ls = ls - lm*60;
		}
	}
	char ch[3]; ch[2] = '\0';
	ltoa(lh, ch, 10);
	if (lh<10)
		s = "0";
	s += ch;
	s+=":"; 
	strset(ch, '0');
	ltoa(lm, ch, 10);
	if (lm<10)
		s += "0";
	s+=ch;
	s+=":"; strset(ch, '0');
	ltoa(ls, ch, 10);
	if (ls<10)
		s += "0";
	s+=ch;
	m_prDlg.m_sTime = " : " + s;
	LeaveCriticalSection(&g_cs);
	if (IsWindow(m_prDlg))
		::SendMessage(m_prDlg.m_hWnd, WM_UPDATELABELS, 0, 0);	
}

void CImportFromExcel::StartImport()
{
	m_prDlg.m_sFile = " : " + m_sFileName;
	m_prDlg.g_cs = &g_cs;
	m_hExcelThread = (HANDLE)_beginthreadex(NULL, 0, ExcelThreadProc, this, 0, NULL);
	m_prDlg.DoModal();
}

void CImportFromExcel::Import()
{
	try
    {
		EnterCriticalSection(&g_cs);
		if (!m_bSave)
			m_sAction = "  -";
		else
			m_sAction = "  -";
		LeaveCriticalSection(&g_cs);
		UpdateDialog();
		_bstr_t squery;
		if (!m_bSave)
		{
			squery = "delete from Prices where ProviderID =";
//		else		
//			squery = "update Prices set new=0 where new=1 and ProviderID =";
		
			_variant_t vid = _variant_t(m_iID);
			vid.ChangeType(VT_BSTR);
			squery += vid.bstrVal;
			m_pCon->Execute(squery, NULL, adExecuteNoRecords);
		}

		EnterCriticalSection(&g_cs);
		m_sAction = "   MS Excel";
		LeaveCriticalSection(&g_cs);
		UpdateDialog();
		Excel::_ApplicationPtr excel;
        HRESULT hr = excel.CreateInstance(__uuidof(Excel::Application));
        Excel::_WorkbookPtr book = excel->Workbooks->_Open( 
        _bstr_t(m_sFileName), vtMissing, vtMissing, vtMissing, vtMissing, 
        vtMissing, vtMissing, vtMissing, vtMissing, vtMissing, vtMissing, 
        vtMissing, vtMissing,0 );

        Excel::_WorksheetPtr sheet = book->Worksheets->Item[m_iLISTNUM];
		
		int ibreakcount=0;
		EnterCriticalSection(&g_cs);
		m_sAction = "  -";
		LeaveCriticalSection(&g_cs);
		UpdateDialog();
		BOOL bUpdate = TRUE;
		for (int irow = m_iROWNUM; irow <= sheet->Rows->GetCount(); irow++)
		{
			_bstr_t sDEVELOPER = "";
			_bstr_t sGROUP = "";
			_bstr_t sCODE = "";
			_bstr_t sORIGINAL = "";
			_bstr_t sNAME = "";
			_bstr_t sMODEL = "";
			_bstr_t sCURRENCY = ""; 
			_bstr_t sEXIST = "";
			double dPRICE = 0;
			double dPRICE2 = 0;
			double dPRICE3 = 0;
			double dPRICE4 = 0;
			RangePtr row = sheet->Rows->Item[irow];
			if (m_iDEVELOPERCOL>=0)
			{
				RangePtr cell = row->Cells->Item[m_iDEVELOPERCOL];
				variant_t v = cell->Value;
				if ((v.vt != VT_EMPTY) && (v.vt != VT_ERROR) && (v.vt != VT_NULL)) 
				{
					v.ChangeType(VT_BSTR);
					sDEVELOPER = v.bstrVal;
				}
			}
			if (m_iGROUPCOL>=0)
			{
				RangePtr cell = row->Cells->Item[m_iGROUPCOL];
				variant_t v = cell->Value;
				if ((v.vt != VT_EMPTY) && (v.vt != VT_ERROR) && (v.vt != VT_NULL)) 
				{
					v.ChangeType(VT_BSTR);
					sGROUP = v.bstrVal;
				}
			}
			if (m_iNAMECOL>=0)
			{
				RangePtr cell = row->Cells->Item[m_iNAMECOL];
				variant_t v = cell->Value;
				if ((v.vt != VT_EMPTY) && (v.vt != VT_ERROR) && (v.vt != VT_NULL)) 
				{
					v.ChangeType(VT_BSTR);
					sNAME = v.bstrVal;
				}
			}
			if (m_iMODELCOL>=0)
			{
				RangePtr cell = row->Cells->Item[m_iMODELCOL];
				variant_t v = cell->Value;
				if ((v.vt != VT_EMPTY) && (v.vt != VT_ERROR) && (v.vt != VT_NULL)) 
				{
					v.ChangeType(VT_BSTR);
					sMODEL = v.bstrVal;
				}
			}
			if (m_iCURRENCYCOL>=0)
			{
				RangePtr cell = row->Cells->Item[m_iCURRENCYCOL];
				variant_t v = cell->Value;
				if ((v.vt != VT_EMPTY) && (v.vt != VT_ERROR) && (v.vt != VT_NULL)) 
				{
					v.ChangeType(VT_BSTR);
					sCURRENCY = v.bstrVal;
				}
			}
			if (m_iORIGINALCOL>=0)
			{
				RangePtr cell = row->Cells->Item[m_iORIGINALCOL];
				variant_t v = cell->Value;
				if ((v.vt != VT_EMPTY) && (v.vt != VT_ERROR) && (v.vt != VT_NULL)) 
				{
					v.ChangeType(VT_BSTR);
					sORIGINAL = v.bstrVal;
				}
			}
			if (m_iCODECOL2>=0)
			{
				RangePtr cell = row->Cells->Item[m_iCODECOL2];
				variant_t v = cell->Value;
				if ((v.vt != VT_EMPTY) && (v.vt != VT_ERROR) && (v.vt != VT_NULL)) 
				{
					v.ChangeType(VT_BSTR);
					if (sORIGINAL.length()>0) 
						sORIGINAL += ";";
					sORIGINAL += (LPCSTR)_bstr_t(v.bstrVal);
				}
			}
			if (m_iCODECOL3>=0)
			{
				RangePtr cell = row->Cells->Item[m_iCODECOL3];
				variant_t v = cell->Value;
				if ((v.vt != VT_EMPTY) && (v.vt != VT_ERROR) && (v.vt != VT_NULL)) 
				{
					v.ChangeType(VT_BSTR);
					if (sORIGINAL.length()>0) 
						sORIGINAL += ";";
					sORIGINAL += (LPCSTR)_bstr_t(v.bstrVal);
				}
			}
			if (m_iCODECOL4>=0)
			{
				RangePtr cell = row->Cells->Item[m_iCODECOL4];
				variant_t v = cell->Value;
				if ((v.vt != VT_EMPTY) && (v.vt != VT_ERROR) && (v.vt != VT_NULL)) 
				{
					v.ChangeType(VT_BSTR);
					if (sORIGINAL.length()>0) 
						sORIGINAL += ";";
					sORIGINAL += (LPCSTR)_bstr_t(v.bstrVal);
				}
			}

			if (m_iEXISTCOL>=0)
			{
				RangePtr cell = row->Cells->Item[m_iEXISTCOL];
				variant_t v = cell->Value;
				if ((v.vt != VT_EMPTY) && (v.vt != VT_ERROR) && (v.vt != VT_NULL)) 
				{
					v.ChangeType(VT_BSTR);
					sEXIST = v.bstrVal;
				}
			}
			if (m_iPRICECOL>=0)
			{
				RangePtr cell = row->Cells->Item[m_iPRICECOL];
				variant_t v = cell->Value;
				if ((v.vt != VT_EMPTY) && (v.vt != VT_ERROR) && (v.vt != VT_NULL)) 
				{
					try
					{
						v.ChangeType(VT_R8);
					}
					catch(...)
					{
						v.ChangeType(VT_BSTR);
						CString sp = (LPCSTR)_bstr_t(v.bstrVal);
						if (sp.Find(".")>=0)
							sp.Replace(".", ",");
						else
							sp.Replace(",", ".");
						v = _variant_t(_bstr_t((LPCSTR)sp));
						try
						{
							v.ChangeType(VT_R8);
						}
						catch(...)
						{
							v.dblVal = 0;
						}
					}
					dPRICE = v.dblVal;
				}
			}
			if (m_iPRICE2COL>=0)
			{
				RangePtr cell = row->Cells->Item[m_iPRICE2COL];
				variant_t v = cell->Value;
				if ((v.vt != VT_EMPTY) && (v.vt != VT_ERROR) && (v.vt != VT_NULL)) 
				{
					try
					{
						v.ChangeType(VT_R8);
					}
					catch(...)
					{
						v.ChangeType(VT_BSTR);
						CString sp = (LPCSTR)_bstr_t(v.bstrVal);
						if (sp.Find(".")>=0)
							sp.Replace(".", ",");
						else
							sp.Replace(",", ".");
						v = _variant_t(_bstr_t((LPCSTR)sp));
						try
						{
							v.ChangeType(VT_R8);
						}
						catch(...)
						{
							v.dblVal = 0;
						}
					}
					dPRICE2 = v.dblVal;
					if (m_iPERCENT2>0)
						dPRICE2 = dPRICE2 - (dPRICE2/100)*m_iPERCENT2;
				}
			}
			if (m_iPRICE3COL>=0)
			{
				RangePtr cell = row->Cells->Item[m_iPRICE3COL];
				variant_t v = cell->Value;
				if ((v.vt != VT_EMPTY) && (v.vt != VT_ERROR) && (v.vt != VT_NULL)) 
				{
					try
					{
						v.ChangeType(VT_R8);
					}
					catch(...)
					{
						v.ChangeType(VT_BSTR);
						CString sp = (LPCSTR)_bstr_t(v.bstrVal);
						if (sp.Find(".")>=0)
							sp.Replace(".", ",");
						else
							sp.Replace(",", ".");
						v = _variant_t(_bstr_t((LPCSTR)sp));
						try
						{
							v.ChangeType(VT_R8);
						}
						catch(...)
						{
							v.dblVal = 0;
						}
					}
					dPRICE3 = v.dblVal;
					if (m_iPERCENT3>0)
						dPRICE3 = dPRICE3 - (dPRICE3/100)*m_iPERCENT3;
				}
			}
			if (m_iPRICE4COL>=0)
			{
				RangePtr cell = row->Cells->Item[m_iPRICE4COL];
				variant_t v = cell->Value;
				if ((v.vt != VT_EMPTY) && (v.vt != VT_ERROR) && (v.vt != VT_NULL)) 
				{
					try
					{
						v.ChangeType(VT_R8);
					}
					catch(...)
					{
						v.ChangeType(VT_BSTR);
						CString sp = (LPCSTR)_bstr_t(v.bstrVal);
						if (sp.Find(".")>=0)
							sp.Replace(".", ",");
						else
							sp.Replace(",", ".");
						v = _variant_t(_bstr_t((LPCSTR)sp));
						try
						{
							v.ChangeType(VT_R8);
						}
						catch(...)
						{
							v.dblVal = 0;
						}
					}
					dPRICE4 = v.dblVal;
					if (m_iPERCENT4>0)
						dPRICE4 = dPRICE4 - (dPRICE4/100)*m_iPERCENT4;
				}
			}
			RangePtr cell = row->Cells->Item[m_iCODECOL];
			variant_t v = cell->Value;
			if ((v.vt != VT_EMPTY) && (v.vt != VT_ERROR) && (v.vt != VT_NULL)) 
			{
				v.ChangeType(VT_BSTR);
				sCODE = v.bstrVal;
			}
			if (sCODE.length()>0)
			{
				m_pRecPrice->AddNew();

				if (sDEVELOPER.length()<=0)
					sDEVELOPER = m_sDEVELOPERDEF;
				if (sDEVELOPER.length()>0)
					m_pRecPrice->Fields->GetItem(_bstr_t("DEVELOPER"))->put_Value(_variant_t(sDEVELOPER));
			
				if (sGROUP.length()<=0)
					sGROUP = m_sGROUPDEF;
				if (sGROUP.length()>0)
					m_pRecPrice->Fields->GetItem(_bstr_t("GROUPNAME"))->put_Value(_variant_t(sGROUP));
				
				if (sMODEL.length()<=0)
					sMODEL = m_sMODELDEF;
				if (sMODEL.length()>0)
					m_pRecPrice->Fields->GetItem(_bstr_t("MODEL"))->put_Value(_variant_t(sMODEL));

				if (sCURRENCY.length()<=0)
					sCURRENCY = m_sCURRENCYDEF;
				if (sCURRENCY.length()>0)
					m_pRecPrice->Fields->GetItem(_bstr_t("CURRENCY"))->put_Value(_variant_t(sCURRENCY));

				if (sEXIST.length()<=0)
					sEXIST = m_sEXISTDEF;
				if (sEXIST.length()>0)
					m_pRecPrice->Fields->GetItem(_bstr_t("EXIST"))->put_Value(_variant_t(sEXIST));

				if (sORIGINAL.length()>0)
					m_pRecPrice->Fields->GetItem(_bstr_t("ORIGINAL"))->put_Value(_variant_t(sORIGINAL));

				if (dPRICE>=0)
					m_pRecPrice->Fields->GetItem(_bstr_t("PRICE"))->put_Value(_variant_t((double)dPRICE));
				if (dPRICE2>=0)
					m_pRecPrice->Fields->GetItem(_bstr_t("PRICE2"))->put_Value(_variant_t((double)dPRICE2));
				if (dPRICE3>=0)
					m_pRecPrice->Fields->GetItem(_bstr_t("PRICE3"))->put_Value(_variant_t((double)dPRICE3));
				if (dPRICE4>=0)
					m_pRecPrice->Fields->GetItem(_bstr_t("PRICE4"))->put_Value(_variant_t((double)dPRICE4));

				if (sNAME.length()>0)
					m_pRecPrice->Fields->GetItem(_bstr_t("NAME"))->put_Value(_variant_t(sNAME));

				m_pRecPrice->Fields->GetItem(_bstr_t("ProviderId"))->put_Value(_variant_t((long)m_iID));
				m_pRecPrice->Fields->GetItem(_bstr_t("CODE"))->put_Value(_variant_t(sCODE));
				EnterCriticalSection(&g_cs);
				m_lCurrentRows = irow;
				if ((m_lCurrentRows-m_iROWNUM)>=0)
					m_lCurrentRows -= m_iROWNUM;
				LeaveCriticalSection(&g_cs);
				UpdateDialog();
				ibreakcount = 0;
			}
			else
				ibreakcount++;
			if (ibreakcount>1000)
				break;
			EnterCriticalSection(&g_cs);
			if (!m_bStarted)
			{
				bUpdate = FALSE;
				break;
			}
			LeaveCriticalSection(&g_cs);
		}
		if (bUpdate)
		{
			EnterCriticalSection(&g_cs);
			m_sAction = " -    MS SQL   ";
			LeaveCriticalSection(&g_cs);
			UpdateDialog();
			m_pRecPrice->UpdateBatch(adAffectAll);
			m_pRec->Fields->GetItem(_bstr_t("LASTFILE"))->put_Value(_variant_t(_bstr_t((LPCSTR)m_sFileName)));
			m_pRec->Update();
			EnterCriticalSection(&g_cs);
			m_sAction = "-     MS SQL";
			LeaveCriticalSection(&g_cs);
		}
		else
		{
			EnterCriticalSection(&g_cs);
			m_sAction = "  ";
			LeaveCriticalSection(&g_cs);
			UpdateDialog();
			m_pRecPrice->CancelUpdate();
		}
		m_pRec->Close();
		m_pRecPrice->Close();
        excel->Quit();
		EnterCriticalSection(&g_cs);
		m_bStarted = FALSE;
		LeaveCriticalSection(&g_cs);
		UpdateDialog();
	}
    catch (_com_error const &e)
    {
		EnterCriticalSection(&g_cs);
		m_bStarted = FALSE;
		LeaveCriticalSection(&g_cs);
        UpdateDialog();
		HRESULT err = e.Error();
		CString s = e.ErrorMessage();
		s += " "; s += (LPCSTR)e.Description();
		MessageBox(NULL, s, e.Source(), MB_OK);
    }
}

void CImportFromExcel::OpenRecordsets()
{
	EnterCriticalSection(&g_cs);
	m_sAction = "   ";
	LeaveCriticalSection(&g_cs);
	try
	{
		CoCreateInstance(__uuidof(Recordset), NULL, CLSCTX_ALL, __uuidof(_Recordset), (void**)&m_pRec);
		m_pRec->CursorLocation = adUseClient;
		_bstr_t squery = "select id, ";
		squery += "DEVELOPERCOL, DEVELOPERDEF,GROUPCOL,GROUPDEF,CODECOL,CODECOL2,CODECOL3,CODECOL4,CODEDEF,NAMECOL,";
		squery += "NAMEDEF,MODELCOL,MODELDEF,PRICECOL,PRICE2COL,PRICE3COL,PRICE4COL,PERCENT2,PERCENT3,PERCENT4, CURRENCYCOL,CURRENCYDEF,";
		squery += "EXISTCOL,EXISTDEF,LASTFILE,LISTNUM,ROWNUM, ORIGINALCOL ";
		squery += " from providers where id = ";
		_variant_t vid = _variant_t(m_iID);
		vid.ChangeType(VT_BSTR);
		squery += vid.bstrVal;
		m_pRec->Open(squery, _variant_t((IDispatch *)m_pCon,true), adOpenForwardOnly, adLockOptimistic, adCmdUnspecified);
		VARIANT vVal;
		m_pRec->Fields->GetItem(_bstr_t("LISTNUM"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iLISTNUM = v.lVal;
		}
		m_pRec->Fields->GetItem(_bstr_t("ROWNUM"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iROWNUM = v.lVal;
		}
		
		m_pRec->Fields->GetItem(_bstr_t("DEVELOPERCOL"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iDEVELOPERCOL = v.lVal;
		}
		m_pRec->Fields->GetItem(_bstr_t("DEVELOPERDEF"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			m_sDEVELOPERDEF = (LPCSTR)_bstr_t(vVal.bstrVal);

		m_pRec->Fields->GetItem(_bstr_t("GROUPCOL"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iGROUPCOL = v.lVal;
		}
		m_pRec->Fields->GetItem(_bstr_t("GROUPDEF"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			m_sGROUPDEF = (LPCSTR)_bstr_t(vVal.bstrVal);

		m_pRec->Fields->GetItem(_bstr_t("ORIGINALCOL"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iORIGINALCOL = v.lVal;
		}

		m_pRec->Fields->GetItem(_bstr_t("CODECOL"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iCODECOL = v.lVal;
		}
		m_pRec->Fields->GetItem(_bstr_t("CODECOL2"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iCODECOL2 = v.lVal;
		}
		m_pRec->Fields->GetItem(_bstr_t("CODECOL3"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iCODECOL3 = v.lVal;
		}
		m_pRec->Fields->GetItem(_bstr_t("CODECOL4"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iCODECOL4 = v.lVal;
		}
		m_pRec->Fields->GetItem(_bstr_t("CODEDEF"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			m_sCODEDEF = (LPCSTR)_bstr_t(vVal.bstrVal);

		m_pRec->Fields->GetItem(_bstr_t("NAMECOL"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iNAMECOL = v.lVal;
		}
		m_pRec->Fields->GetItem(_bstr_t("NAMEDEF"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			m_sNAMEDEF = (LPCSTR)_bstr_t(vVal.bstrVal);

		m_pRec->Fields->GetItem(_bstr_t("MODELCOL"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iMODELCOL = v.lVal;
		}
		m_pRec->Fields->GetItem(_bstr_t("MODELDEF"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			m_sMODELDEF =(LPCSTR)_bstr_t(vVal.bstrVal);

		m_pRec->Fields->GetItem(_bstr_t("PRICECOL"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iPRICECOL = v.lVal;
		}

		m_pRec->Fields->GetItem(_bstr_t("PRICE2COL"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iPRICE2COL = v.lVal;
		}

		m_pRec->Fields->GetItem(_bstr_t("PRICE3COL"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iPRICE3COL = v.lVal;
		}

		m_pRec->Fields->GetItem(_bstr_t("PRICE4COL"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iPRICE4COL = v.lVal;
		}

		m_pRec->Fields->GetItem(_bstr_t("PERCENT2"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iPERCENT2 = v.lVal;
		}

		m_pRec->Fields->GetItem(_bstr_t("PERCENT3"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iPERCENT3 = v.lVal;
		}

		m_pRec->Fields->GetItem(_bstr_t("PERCENT4"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iPERCENT4 = v.lVal;
		}

		m_pRec->Fields->GetItem(_bstr_t("CURRENCYCOL"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iCURRENCYCOL = v.lVal;
		}
		m_pRec->Fields->GetItem(_bstr_t("CURRENCYDEF"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			if (v.lVal == 0)
				m_sCURRENCYDEF = "EUR";
			if (v.lVal == 1)
				m_sCURRENCYDEF = "USD";
			if (v.lVal == 2)
				m_sCURRENCYDEF = "";
		}

		m_pRec->Fields->GetItem(_bstr_t("EXISTCOL"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		{
			_variant_t v = vVal;
			v.ChangeType(VT_I4);
			m_iEXISTCOL = v.lVal;
		}
		m_pRec->Fields->GetItem(_bstr_t("EXISTDEF"))->get_Value(&vVal);
		if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			m_sEXISTDEF = (LPCSTR)_bstr_t(vVal.bstrVal);
		_bstr_t queryprov = "SELECT id, ProviderId, DEVELOPER, GROUPNAME, CODE, NAME,";
		queryprov += " MODEL, PRICE, PRICE2, PRICE3, PRICE4, CURRENCY, EXIST, ORIGINAL"; 
		queryprov += " FROM Prices ";
		queryprov += " WHERE  id = -1";
		CoCreateInstance(__uuidof(Recordset), NULL, CLSCTX_ALL, __uuidof(_Recordset), (void**)&m_pRecPrice);
		m_pRecPrice->CursorLocation = adUseClient;
		m_pRecPrice->Open(queryprov, _variant_t((IDispatch *)m_pCon,true), adOpenForwardOnly, adLockBatchOptimistic, adCmdUnspecified);
	}
    catch (_com_error const &e)
    {
        HRESULT err = e.Error();
		CString s = e.ErrorMessage();
		s += " "; s += (LPCSTR)e.Description();
		MessageBox(NULL, s, e.Source(), MB_OK);
    }
}