// MailOptionsDlg.cpp : implementation file
//
#include "stdafx.h"
#include "MailOptionsDlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
// CMailOptionsDlg dialog

CMailOptionsDlg::CMailOptionsDlg()
{
}

void CMailOptionsDlg::Apply()
{
	CString s;

	VARIANT vNULL; vNULL.vt = VT_NULL;

	try
	{
		m_EMail.GetWindowText(s);
		if (s.GetLength()>0)
			m_pRec->Fields->GetItem(_bstr_t("EMail"))->put_Value(_variant_t(_bstr_t((LPCSTR)s)));
		else
			m_pRec->Fields->GetItem(_bstr_t("EMail"))->put_Value(vNULL);

		m_CCAddress.GetWindowText(s);
		if (s.GetLength()>0)
			m_pRec->Fields->GetItem(_bstr_t("CCAddress"))->put_Value(_variant_t(_bstr_t((LPCSTR)s)));
		else
			m_pRec->Fields->GetItem(_bstr_t("CCAddress"))->put_Value(vNULL);

		m_Server.GetWindowText(s);
		if (s.GetLength()>0)
			m_pRec->Fields->GetItem(_bstr_t("smtpServer"))->put_Value(_variant_t(_bstr_t((LPCSTR)s)));
		else
			m_pRec->Fields->GetItem(_bstr_t("smtpServer"))->put_Value(vNULL);

		m_Port.GetWindowText(s);
		if (s.GetLength()>0)
		{
			_variant_t vport = _bstr_t(s);
			vport.ChangeType(VT_I4);
			m_pRec->Fields->GetItem(_bstr_t("smtpport"))->put_Value(vport);
		}
		else
			m_pRec->Fields->GetItem(_bstr_t("smtpport"))->put_Value(_variant_t(25));

		m_User.GetWindowText(s);
		if (s.GetLength()>0)
			m_pRec->Fields->GetItem(_bstr_t("smtpuser"))->put_Value(_variant_t(_bstr_t((LPCSTR)s)));
		else
			m_pRec->Fields->GetItem(_bstr_t("smtpuser"))->put_Value(vNULL);

		m_Password.GetWindowText(s);
		if (s.GetLength()>0)
			m_pRec->Fields->GetItem(_bstr_t("smtppassword"))->put_Value(_variant_t(_bstr_t((LPCSTR)s)));
		else
			m_pRec->Fields->GetItem(_bstr_t("smtppassword"))->put_Value(vNULL);

		m_pRec->Update();
		m_pRec->Close();
	}
	catch (_com_error const &e)
    {
		CString sm = e.ErrorMessage();
		sm += " "; sm += (LPCSTR)e.Description();
		MessageBox(sm, e.Source(), MB_OK);
    }
}

void CMailOptionsDlg::OpenRecordset()
{
	try
	{
		CoCreateInstance(__uuidof(Recordset), NULL, CLSCTX_ALL, __uuidof(_Recordset), (void**)&m_pRec);
		m_pRec->CursorLocation = adUseClient;
		_bstr_t squery = "select id, email, ccaddress, smtpport, smtpuser, smtppassword, smtpserver from info";
		m_pRec->Open(squery, _variant_t((IDispatch *)m_pCon,true), adOpenForwardOnly, adLockOptimistic, adCmdUnspecified);
		if (m_pRec->RecordCount<=0) 
			m_pRec->AddNew();
		else
		{
			VARIANT vVal;
			m_pRec->Fields->GetItem(_bstr_t("email"))->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
				m_EMail.SetWindowText((LPCSTR)_bstr_t(vVal.bstrVal));
			m_pRec->Fields->GetItem(_bstr_t("ccaddress"))->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
				m_CCAddress.SetWindowText((LPCSTR)_bstr_t(vVal.bstrVal));
			m_pRec->Fields->GetItem(_bstr_t("smtpport"))->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
			{
				_variant_t vport = vVal;
				vport.ChangeType(VT_BSTR);
				m_Port.SetWindowText((LPCSTR)_bstr_t(vport.bstrVal));
			}
			m_pRec->Fields->GetItem(_bstr_t("smtpuser"))->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
				m_User.SetWindowText((LPCSTR)_bstr_t(vVal.bstrVal));
			m_pRec->Fields->GetItem(_bstr_t("smtppassword"))->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
				m_Password.SetWindowText((LPCSTR)_bstr_t(vVal.bstrVal));
			m_pRec->Fields->GetItem(_bstr_t("smtpserver"))->get_Value(&vVal);
			if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
				m_Server.SetWindowText((LPCSTR)_bstr_t(vVal.bstrVal));
		}
	}
	catch (_com_error const &e)
    {
		CString sm = e.ErrorMessage();
		sm += " "; sm += (LPCSTR)e.Description();
		MessageBox(sm, e.Source(), MB_OK);
    }
}

LRESULT CMailOptionsDlg::OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	m_EMail = GetDlgItem(IDC_EMAIL);
	m_CCAddress = GetDlgItem(IDC_CCADDRESS);
	m_Server = GetDlgItem(IDC_SMTPSERVER);
	m_Port = GetDlgItem(IDC_SMTPPORT);
	m_User = GetDlgItem(IDC_SMTPUSER);
	m_Password = GetDlgItem(IDC_SMTPPASSWORD);

	OpenRecordset();

	CenterWindow(::GetDesktopWindow());
	return TRUE;
}

LRESULT CMailOptionsDlg::OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	EndDialog(wID);
	return 0;
}

LRESULT CMailOptionsDlg::OnOk(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	Apply();
	EndDialog(IDOK);
	return 0;
}