// MainFrm.cpp : implmentation of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"

#include "PriceView.h"
#include "MainFrm.h"
#include "Fontandsize.h"
#include "Utils.h"
#include "ConnectionPropDlg.h"
#include "ProviderList.h"
#include "OrderList.h"
#include "OrderHeadDlg.h"
#include "MailOptionsDlg.h"

BOOL CMainFrame::PreTranslateMessage(MSG* pMsg)
{
	if((pMsg->message == WM_KEYDOWN) && (pMsg->wParam == VK_RETURN))
    {
        static const TCHAR szEdit[] = _T("edit");
        TCHAR szCompare[sizeof(szEdit)+1];
        HWND hFocus = ::GetFocus();
        ::GetClassName(hFocus, szCompare, sizeof(szCompare));
        if(!lstrcmpi(szCompare, szEdit))
        {
            if(::GetWindowLong(hFocus, GWL_STYLE) & ES_WANTRETURN)
			{
				m_PriceView.m_bFindInFound = FALSE;
				m_PriceView.Find();  
				return FALSE;
			}
			else
                return CFrameWindowImpl<CMainFrame>::PreTranslateMessage(pMsg);
        }
        if (::SendMessage(hFocus,WM_GETDLGCODE,0,0) &
            (DLGC_WANTALLKEYS | DLGC_WANTMESSAGE))
            return FALSE;       
    }
	return CFrameWindowImpl<CMainFrame>::PreTranslateMessage(pMsg);
}

BOOL CMainFrame::OnIdle()
{
	UIUpdateToolBar();
	return FALSE;
}

LRESULT CMainFrame::OnPostCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	ShowWindow(SW_SHOWMAXIMIZED);
	m_PriceSplitter.SetSplitterPos(400);
	return 0;
}

LRESULT CMainFrame::OnExcel(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_PriceView.ListToExcel();
	return 0;
}
LRESULT CMainFrame::OnOrderMail(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_PriceView.OrderToEMail();
	return 0;
}

LRESULT CMainFrame::OnMailOptions(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CMailOptionsDlg dlg;
	dlg.m_pCon = m_pCon;
	dlg.DoModal();
	return 0;
}

LRESULT CMainFrame::OnInfo(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	COrderHeadDlg dlg;
	dlg.m_bMail = TRUE;
	dlg.m_pCon = m_pCon;
	dlg.DoModal();
	return 0;
}

LRESULT CMainFrame::OnOrderExcel(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_PriceView.OrderToExcel();
	return 0;
}


LRESULT CMainFrame::OnCopy(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_PriceView.CopyCell();
	return 0;
}

LRESULT CMainFrame::OnEdit(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_PriceView.Edit();
	return 0;
}

LRESULT CMainFrame::OnAsc(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_PriceView.Sort(TRUE);
	return 0;
}
LRESULT CMainFrame::OnDesc(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_PriceView.Sort(FALSE);
	return 0;
}

LRESULT CMainFrame::OnShowExist(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	m_tabbedChildWindow.DisplayTab(m_ExistView, TRUE, TRUE);
	return 0;
}


LRESULT CMainFrame::OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	if (!Connect())
		exit(0);
	HWND hWndCmdBar = m_CmdBar.Create(m_hWnd, rcDefault, NULL, ATL_SIMPLE_CMDBAR_PANE_STYLE);
	m_CmdBar.AttachMenu(GetMenu());
	m_CmdBar.LoadImages(IDR_MAINIMAGES);
	SetMenu(NULL);
	
	HWND hWndToolBar = CreateSimpleToolBarCtrl(m_hWnd, IDR_MAINFRAME, FALSE, ATL_SIMPLE_TOOLBAR_PANE_STYLE | TBSTYLE_LIST);
    InitToolBar(hWndToolBar, IDR_MAINFRAME);
    CToolBarCtrl tb = hWndToolBar;
      
	
	CreateSimpleReBar(ATL_SIMPLE_REBAR_NOBORDER_STYLE);
	AddSimpleReBarBand(hWndCmdBar);
	AddSimpleReBarBand(hWndToolBar, NULL, TRUE);
	AddButtonText(tb, ID_PROVIDERS, IDS_PROVIDERS);
	AddButtonText(tb, ID_ADDPRICE, IDS_ADDPRICE);
	AddButtonText(tb, ID_ORDERS, IDS_ORDERS);
	tb.AutoSize();

	m_CmdBar.AddToolbar(hWndToolBar);
	m_CmdBar.Prepare();
	UIAddToolBar(ctrlToolbar);

	CheckMenuItem(m_CmdBar.m_hMenu, ID_VIEW_TOOLBAR, MF_CHECKED);
	CheckMenuItem(m_CmdBar.m_hMenu, ID_VIEW_STATUS_BAR, MF_CHECKED);

	m_PriceView.m_pCmdBar = &m_CmdBar;
	m_PriceView.m_lSize = m_lSize;
	m_PriceView.m_sFont = m_sFont;
	m_PriceView.m_pCon = m_pCon;
	m_PriceView.m_pExist = &m_ExistView;
	m_PriceView.m_pDetail = &m_PriceDetail;

	m_PriceDetail.m_pCon = m_pCon;

	m_tabbedChildWindow.SetReflectNotifications(true);
	m_tabbedChildWindow.SetTabStyles(CTCS_TOOLTIPS | CTCS_BOLDSELECTEDTAB | CTCS_SCROLL );
	m_hWndClient = m_tabbedChildWindow.Create(m_hWnd, rcDefault, NULL, 0, WS_EX_TOPMOST);

	m_PriceSplitter.Create(m_tabbedChildWindow, rcDefault, NULL, WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN, WS_EX_WINDOWEDGE);
	m_PriceSplitter.SetSplitterExtendedStyle(SPLIT_PROPORTIONAL);
	
	m_PriceView.Create(m_PriceSplitter, rcDefault);
	m_PriceView.m_hWndParent = m_hWnd;
	
	m_PriceDetail.Create(m_PriceSplitter, rcDefault, _T("about:blank"), WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_HSCROLL | WS_VSCROLL, WS_EX_CLIENTEDGE);
	//m_PriceDetail.m_hWndParent = m_hWnd;

	m_ExistView.Create(m_tabbedChildWindow, rcDefault, _T("http://www.exist.ru"), WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_HSCROLL | WS_VSCROLL, WS_EX_CLIENTEDGE);
	
	m_tabbedChildWindow.AddTabWithIcon(m_PriceSplitter, _T("    "), IDI_PRICE);
	m_tabbedChildWindow.AddTabWithIcon(m_ExistView, _T("  Exist"), IDI_EXIST);
	m_tabbedChildWindow.DisplayTab(m_ExistView, TRUE, TRUE);
	m_tabbedChildWindow.DisplayTab(m_PriceSplitter, TRUE, TRUE);

	CMessageLoop* pLoop = _Module.GetMessageLoop();
	ATLASSERT(pLoop != NULL);
	pLoop->AddMessageFilter(this);
	pLoop->AddIdleHandler(this);

	UISetCheck(ID_VIEW_TOOLBAR, TRUE);

	UpdateLayout();

	RECT rc = {0,100,0,110};
	m_PriceSplitter.SetSplitterRect(&rc);

	UpdateLayout();
	m_PriceSplitter.SetSplitterPanes(m_PriceView, m_PriceDetail, TRUE);
	this->PostMessage(WM_POSTCREATE);
	
	return 0;
}

LRESULT CMainFrame::OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	m_PriceView.m_List.SaveOrderArray();
	::exit(0);
	return 0;
}

LRESULT CMainFrame::OnOrders(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	COrderList dlg;
	dlg.m_pCon = m_pCon;
	dlg.DoModal();
	return 0;
}

LRESULT CMainFrame::OnFileExit(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	PostMessage(WM_CLOSE);
	return 0;
}

LRESULT CMainFrame::OnFont(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CFontandsize dlg;
	dlg.m_sFont = m_sFont;
	dlg.m_lSize = m_lSize;
	if (dlg.DoModal()==IDOK)
	{
		m_sFont = dlg.m_sFont;
		m_lSize = dlg.m_lSize;
		CUtils ut;
		_variant_t v = m_lSize;
		v.ChangeType(VT_BSTR);
		ut.WriteToReg(CString((LPCSTR)_bstr_t(v.bstrVal)),CString("FontSize"));
		ut.WriteToReg(m_sFont,CString("FontName"));
		//m_PriceView.SetFont();
		//m_PriceDetail.SetFont();
	}
	return 0;
}

LRESULT CMainFrame::OnViewToolBar(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	static BOOL bVisible = TRUE;	// initially visible
	bVisible = !bVisible;
	CReBarCtrl rebar = m_hWndToolBar;
	int nBandIndex = rebar.IdToIndex(ATL_IDW_BAND_FIRST + 1);	// toolbar is 2nd added band
	rebar.ShowBand(nBandIndex, bVisible);
	UISetCheck(ID_VIEW_TOOLBAR, bVisible);
	UpdateLayout();
	return 0;
}

BOOL CMainFrame::Connect()
{
	m_sFont = "MS Sans Serif";
	m_lSize = 9;

	CUtils ut;
	CString f = ut.ReadFromReg(CString("FontName"));
	if (f.GetLength()>0)
	{
		m_sFont = f;
		f = ut.ReadFromReg(CString("FontSize"));
		if (f.GetLength()>0)
		{
			_variant_t v = _bstr_t(f);
			v.ChangeType(VT_I4);
			m_lSize = v.lVal;
		}
	}
	return TRUE;
}

BOOL CMainFrame::RefreshConnection()
{
	CUtils ut;
	if ((ut.ReadFromReg(CString("Server")).GetLength()<=0) || (ut.ReadFromReg(CString("Database")).GetLength()<=0))return FALSE;
	CString sCon =ut.GetConnectionString();
	try
	{
		if (m_pCon == NULL)
			CoCreateInstance(__uuidof(ADODB::Connection),NULL, CLSCTX_ALL, __uuidof(ADODB::_Connection), (void**)&m_pCon);
		if (m_pCon==NULL)
		{
			::MessageBox(NULL, _T("ADO Connection object creation failed"), _T("Connection error"), MB_OK);
			return FALSE;
		}
		if (m_pCon->State == adStateOpen) return TRUE;
		m_pCon->CursorLocation = adUseClient;
		m_pCon->Open(_bstr_t((LPCTSTR)sCon), L"", L"", adConnectUnspecified);
		if( (m_pCon->Errors->Count) > 0)
		{
			long nCount = m_pCon->Errors->Count;
			for(long i = 0; i < nCount; i++)
				::MessageBox(NULL, (LPCTSTR)m_pCon->Errors->GetItem(i)->Description, _T("Connection error"), MB_OK);
			return FALSE;
		}
	}
	catch( _com_error &e)
	{
		::MessageBox(NULL,(LPCTSTR)e.Description(),(LPCTSTR)e.Source(), MB_OK);
		m_pCon.Release();
		return FALSE;
	}
	return TRUE;
}

BOOL CMainFrame::DatabaseConnect()
{
	CConnectionPropDlg dlg;
	CUtils ut;
	dlg.m_sServer = ut.ReadFromReg(CString("Server"));
	dlg.m_sDatabase = ut.ReadFromReg(CString("Database"));
	dlg.m_sUser = ut.ReadFromReg(CString("User"));
	dlg.m_sPassword = ut.ReadFromReg(CString("Password"));
	if (dlg.DoModal() == IDOK)
	{
		ut.WriteToReg(dlg.m_sServer, CString("Server"));
		ut.WriteToReg(dlg.m_sDatabase, CString("Database"));
		ut.WriteToReg(dlg.m_sUser, CString("User"));
		ut.WriteToReg(dlg.m_sPassword, CString("Password"));
	}
	return RefreshConnection();
}

LRESULT CMainFrame::OnProviders(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CProviderList dlg;
	dlg.m_lSize = m_lSize;
	dlg.m_sFont = m_sFont;
	dlg.m_sCaption = "";
	dlg.m_pCon = m_pCon;
	dlg.m_bSelect = FALSE;
	dlg.DoModal();
	return 0;
}

LRESULT CMainFrame::OnAddPrice(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CUtils ut;
	CString sPath = ut.ReadFromReg(CString("LastPathName"));
	CString sFile;
	CFileDialog dlg(TRUE, _T("xls"), NULL, OFN_FILEMUSTEXIST, _T("MS Excel WorkSheets (*.xls)\0*.xls\0All Files (*.*)\0*.*\0"), m_hWnd);
    dlg.m_ofn.lpstrTitle = " -  ";
	if (sPath.GetLength()>0)
		dlg.m_ofn.lpstrInitialDir = sPath;
    if (dlg.DoModal() == IDCANCEL)
        return 0;
	sFile = dlg.m_szFileName;
	sPath = sFile;
	sPath = sPath.Left(sPath.ReverseFind('\\'));
	ut.WriteToReg(sPath, CString("LastPathName"));
	
	CProviderList dlgp;
	dlgp.m_lSize = m_lSize;
	dlgp.m_sFont = m_sFont;
	dlgp.m_sCaption = " . : ";
	dlgp.m_sCaption+=sFile;
	dlgp.m_pCon = m_pCon;
	dlgp.m_bSelect = TRUE;
	dlgp.m_sLastFile = sFile;
	dlgp.DoModal();

	return 0;
}

