// OrderList.cpp : implementation of the CListDlg class
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "OrderList.h"

COrderList::COrderList()
{
	m_sSelect = "";
	m_sCondition = "";
	m_sCaption="";
	m_pCon = NULL;
	m_pRec = NULL;
	m_bInit = TRUE;
	m_sFont = "MS Sans Serif";
	m_lSize = 9;
	fnt = 0;
}

void COrderList::Find()
{
	CString s = "";
	m_Combo.GetWindowText(s);
	if (s.GetLength()<=0) 
	{ 
		MessageBox("    ", "", MB_OK);
		m_Combo.SetFocus();
		return; 
	}
	else 
		if (-1 != m_List.Find(s))
			if ((0>m_Combo.FindString(0, s)) && (m_Combo.GetCount()<20)) m_Combo.AddString(s);
}

LRESULT COrderList::OnRefresh(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	Reload();
	return 0;
}

void COrderList::View()
{
	if (m_List.GetItemCount()<=0) {MessageBox("    ", " ", MB_OK); return;}
	int iItem = m_List.GetSelectedIndex(); 
	if (iItem>=0)
	{
		CString s;
		m_List.GetItemText(iItem, 3, s);
		::ShellExecute(NULL,"open", "EXCEL.EXE", s, NULL, SW_SHOWDEFAULT ); 
	}
}
void COrderList::Delete()
{
	if (m_List.GetItemCount()<=0) {MessageBox("    "," ",MB_OK); return;}
	int iItem = m_List.GetSelectedIndex(); 
	if (iItem>=0)
	{
		if (MessageBox("     .  ?"," ",MB_OKCANCEL)==IDOK)
		{
			long dwi = m_List.GetItemData(iItem);
			CString s;
			m_List.GetItemText(iItem, 2, s);
			_variant_t vv(dwi);
			vv.ChangeType(VT_BSTR);
			CComBSTR qr("delete from orders where id =");
			qr.AppendBSTR(vv.bstrVal);
			try{ m_pCon->Execute(qr.m_str, NULL, adExecuteNoRecords);}
			catch (_com_error &e) { MessageBox(e.Description(), e.Source() , MB_OK); return;}
			m_pRec->Requery(adCmdUnspecified);
			m_List.DeleteItem(iItem);
			m_List.SelectItem(iItem-1);
			DeleteFile(s);
			return;
		}
	}
}

LRESULT COrderList::OnAsc(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_List.Sort(TRUE);
	m_List.RefreshData(m_pRec);
	return 0;
}
LRESULT COrderList::OnDesc(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_List.Sort(FALSE);
	m_List.RefreshData(m_pRec);
	return 0;
}

LRESULT COrderList::OnView(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	View();
	m_List.SetFocus();
	return 0;
}
LRESULT COrderList::OnDelete(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	Delete();
	m_List.SetFocus();
	return 0;
}

void COrderList::SetCondition()
{
	m_sCondition = "";
	_variant_t v;
	m_Date.GetDate(v);
	v.ChangeType(VT_R8);
	long ld = (long)v.dblVal;
	if (((double)ld - v.dblVal)>0)
		ld = ld - 1;
	ld = ld -2;
	_variant_t vd = ld; vd.ChangeType(VT_BSTR);
	m_sCondition = " where convert(real, createdate)>=";
	m_sCondition += vd.bstrVal;
	m_sCondition += " and convert(real, createdate)<";
	vd = _variant_t(ld+1); vd.ChangeType(VT_BSTR);
	m_sCondition += vd.bstrVal;
	CString s; m_Provider.GetWindowText(s);
	if (s.GetLength()>0)
	{
		s.MakeUpper();
		m_sCondition += " and UPPER(Provider) like '%";
		m_sCondition += s; m_sCondition += "%'";
	}
}

LRESULT COrderList::OnFilter(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	SetCondition();
	Reload();
	m_List.SetFocus();
	return 0;
}

LRESULT COrderList::OnAll(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_sCondition = "";
	Reload();
	m_List.SetFocus();
	return 0;
}

LRESULT COrderList::OnRclickList(int idCtrl, LPNMHDR pnmh, BOOL& bHandled)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pnmh);
	m_List.m_iCol = pNMLV->iSubItem;
	CMenuHandle menu = LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_ORDER));
	CMenuHandle submenu = menu.GetSubMenu(0);
	LPNMITEMACTIVATE	pItemActivate = (LPNMITEMACTIVATE)pnmh;
	POINT pt = pItemActivate->ptAction; 
    ::ClientToScreen(m_List.m_hWnd, &pt);
	m_CmdBar.TrackPopupMenu(submenu, TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y);
	return 0;
}

LRESULT COrderList::OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_List.SaveOrderArray();
	DeleteObject(fnt);
	EndDialog(wID);
	return 0;
}

LRESULT COrderList::OnDblclkList(int idCtrl, LPNMHDR pnmh, BOOL& bHandled)
{
	if (m_List.GetItemCount()<=0) 
	{
		MessageBox("    ", "", MB_OK); 
		return 0;
	}
	int iItem = m_List.GetSelectedIndex(); 
	if (iItem>=0)
		View();
	else
	{
		MessageBox("    ", "", MB_OK); 
		return 0;
	}
	return 0;
}

void COrderList::SetFont()
{
	if (fnt!=0)
	{
		fnt.Detach();
		DeleteObject(fnt);
	}
	fnt = NULL;
	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT));
	CClientDC dc(m_hWnd);
	lf.lfHeight = -MulDiv(m_lSize, GetDeviceCaps(dc.m_hDC, LOGPIXELSY), 72);;                      
#ifdef UNICODE
	wcscpy(lf.lfFaceName, m_sFont); 
#else
	strcpy(lf.lfFaceName, m_sFont); 
#endif
	lf.lfCharSet = RUSSIAN_CHARSET;
	fnt.CreateFontIndirect(&lf);
	m_List.SetFont(fnt);
}

void COrderList::InitList()
{
	m_List.SubclassWindow(GetDlgItem(IDC_LIST), "OrderList");
	m_List.AddCol(CString(""), 0, 80);
	m_List.AddCol(CString(""), 1, 200);
	m_List.AddCol(CString("   "), 2, 150);
	m_List.AddCol(CString(" "), 3, 600);
	m_List.SetOrder();
	SetFont();
}

void COrderList::Reload()
{
	try
	{
		CComBSTR qr((LPCSTR)m_sSelect);
		if (m_sCondition.GetLength()>0)
			qr.Append((LPCSTR)m_sCondition);
		if (m_pRec == NULL)
			CoCreateInstance(__uuidof(Recordset), NULL, CLSCTX_ALL, __uuidof(_Recordset), (void**)&m_pRec);
		else
			m_pRec->Close();
		m_pRec->CursorLocation = adUseClient;
		m_pRec->Open(qr.m_str, _variant_t((IDispatch *)m_pCon,true), adOpenForwardOnly, adLockOptimistic, adCmdUnspecified);
		m_List.RefreshData(m_pRec);
	}
	catch( _com_error &e)
	{
		CString msg = "  : ";
		msg += (LPCSTR)e.Description();
		CString stitle = " :";
		stitle += (LPCSTR)e.Source();
		MessageBox(msg , stitle , MB_OK);
	}
	m_List.SetFocus();
}

BOOL COrderList::PreTranslateMessage(MSG* pMsg)
{
	return IsDialogMessage(pMsg);
}

LRESULT COrderList::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	m_Date = GetDlgItem(IDC_DATE);
	m_Provider = GetDlgItem(IDC_PROVIDER);

	SetWindowText(m_sCaption);
	InitList();
	m_sSelect = "select id, OrderType, Provider, CreateDate, FileName from orders";
	SetCondition();
	Reload();
	m_bInit = FALSE;
	m_List.SelectItem(0);
	
	m_CmdBar.Create(m_hWnd, rcDefault, NULL, ATL_SIMPLE_CMDBAR_PANE_STYLE);
	m_CmdBar.LoadImages(IDR_MAINIMAGES);
	RECT rcClient;
	GetClientRect(&rcClient);
	m_ctrlToolbar.SubclassWindow( CFrameWindowImplBase<>::CreateSimpleToolBarCtrl(m_hWnd, IDR_ORDER, FALSE, ATL_SIMPLE_TOOLBAR_STYLE | CCS_NODIVIDER | CCS_NOPARENTALIGN | TBSTYLE_LIST | TBSTYLE_FLAT) );
	m_ctrlToolbar.MoveWindow(0,0, rcClient.right - rcClient.left, 10);
	m_ctrlToolbar.AutoSize();	
	m_ctrlToolbar.ModifyStyle(0, CCS_ADJUSTABLE);
	AddButtonText(m_ctrlToolbar, ID_REFRESH, IDS_REFRESH);
	AddButtonText(m_ctrlToolbar, ID_VIEW, IDS_VIEW);
	AddButtonText(m_ctrlToolbar, ID_DELETE, IDS_DELETE);
	AddButtonText(m_ctrlToolbar, ID_FIND, IDS_FIND);
	RECT rcCombo = { 330, 1, 530, 100 }; 
	DWORD dwStyle = WS_CHILD | WS_BORDER | WS_VISIBLE | CBS_DROPDOWN;
	m_Combo.Create(m_hWnd, rcCombo, _T(""), dwStyle);
	m_Combo.SetFont(AtlGetDefaultGuiFont());
	m_Combo.SetParent(m_ctrlToolbar);
	m_Combo.m_hMainWnd = m_hWnd;	
	DlgResize_Init(false, true, WS_CLIPCHILDREN);
	CenterWindow(::GetDesktopWindow());

//	RECT rc, rc1;
//	::GetWindowRect(GetParent(), &rc);
//	GetWindowRect(&rc1);
//	MoveWindow(rc1.left, rc.top, rc1.right - rc1.left, rc1.bottom - rc1.top);
	return TRUE;
}

LRESULT COrderList::OnLvnKeydownList(int /*idCtrl*/, LPNMHDR pNMHDR, BOOL& /*bHandled*/)
{
	LPNMLVKEYDOWN pLVKeyDow = reinterpret_cast<LPNMLVKEYDOWN>(pNMHDR);
	switch (pLVKeyDow->wVKey)
	{
		case VK_SPACE : 
		{ View(); 	m_List.SetFocus();}
		break;
		case VK_DELETE : 
		{ Delete(); m_List.SetFocus(); } 
		break;
		case 'F' : ::SetFocus(m_Combo); break;
		case 'A' : ::SetFocus(m_Combo); break;
		case VK_F3 : Find(); break;
	}
	return 0;
}

