// PriceView.h : interface of the CPriceView class
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include "htmlview.h"
#include "HTMLView.h"

class CPriceView : public CAxDialogImpl<CPriceView>,
	public CDialogResize<CPriceView>
{
	CImageList m_il;
public:
	BOOL m_bFindInFound;
	CHTMLView* m_pExist;
	CHTMLView* m_pDetail;

	CPriceView()
	{
		m_pCon = NULL;
		m_pRec = NULL;
		m_hWndParent = NULL;
		m_sFont = "MS Sans Serif";
		m_lSize = 9;
		fnt = 0;
		m_bFindInFound = FALSE;
	}
	CToolBarXPCtrl m_ctrlToolbar;
	CCommandBarXPCtrl* m_pCmdBar;
	CSortListCtrl m_List;
	CEdit m_FindText;
	CButton m_Like;
	CButton m_All;
	CButton m_Developer;
	CButton m_Provider;
	CButton m_Model;
	CButton m_Name;
	CButton m_Code;
	CButton m_Original;

	HWND m_hWndParent;

	CString m_sFont;
	long m_lSize;
	CFont fnt;

	long m_iID;
	_ConnectionPtr m_pCon;
	_RecordsetPtr  m_pRec;
	CString m_sSelect;
	CString m_sCondition;

	enum { IDD = IDD_PRICE_FORM };

	BOOL PreTranslateMessage(MSG* pMsg);

	BEGIN_MSG_MAP(CPriceView)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
		MESSAGE_HANDLER(WM_SHOWWINDOW, OnShowWindow)
		COMMAND_HANDLER(IDC_ALL, BN_CLICKED, OnBnClickedAll)
		COMMAND_HANDLER(IDC_FIND, BN_CLICKED, OnBnClickedFind)
		NOTIFY_HANDLER(IDC_LIST, LVN_ITEMCHANGED, OnLvnItemchangedList)
		NOTIFY_HANDLER(IDC_LIST, NM_RCLICK, OnRclickList)
		COMMAND_HANDLER(IDC_EXPORT, BN_CLICKED, OnBnClickedExport)
		COMMAND_HANDLER(IDC_ORDERMAIL, BN_CLICKED, OnBnClickedOrdermail)
		COMMAND_HANDLER(IDC_ORDEREXCEL, BN_CLICKED, OnBnClickedOrderexcel)
		COMMAND_HANDLER(IDC_EXIST, BN_CLICKED, OnBnClickedExist)
		COMMAND_HANDLER(IDC_FINDINFOUND, BN_CLICKED, OnBnClickedFindinfound)
		NOTIFY_HANDLER(IDC_LIST, NM_DBLCLK, OnNMDblclkList)
		CHAIN_MSG_MAP( CDialogResize<CPriceView> )
		REFLECT_NOTIFICATIONS()
	END_MSG_MAP()

	BEGIN_DLGRESIZE_MAP(CPriceView)
		DLGRESIZE_CONTROL(IDC_LIST, DLSZ_SIZE_X | DLSZ_SIZE_Y)
	END_DLGRESIZE_MAP()

	void InitList();
	void SetFont();
	void Reload();
	void Find();
	void Edit();
	void CopyCell();
	void ListToExcel();
	void OrderToEMail();
	void OrderToExcel();
	BOOL GetCheckedCount();
	CString GetProviderDir(CString sProv);
	void Sort(BOOL bAsc);

// Handler prototypes (uncomment arguments if needed):
//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnDestroy(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedAll(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnShowWindow(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedFind(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnLvnItemchangedList(int /*idCtrl*/, LPNMHDR pNMHDR, BOOL& /*bHandled*/);
	LRESULT OnRclickList(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);
	LRESULT OnBnClickedExport(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedOrdermail(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedOrderexcel(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedExist(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedFindinfound(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnNMDblclkList(int /*idCtrl*/, LPNMHDR pNMHDR, BOOL& /*bHandled*/);
};
