// ProviderDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Price.h"
#include ".\ProviderDlg.h"
#include ".\importfromexcel.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
// CProviderDlg dialog

CProviderDlg::CProviderDlg()
{
	m_sCaption = "";
	m_bEdit = TRUE;
	m_pRec = NULL;

	m_iID = -1;
	m_bView = FALSE;
	m_bPropChanged = FALSE;
	m_bSelect = FALSE;
	m_sLastFile = "";
}

void CProviderDlg::OpenRecordsets()
{
	try
	{
		CoCreateInstance(__uuidof(Recordset), NULL, CLSCTX_ALL, __uuidof(_Recordset), (void**)&m_pRec);
		m_pRec->CursorLocation = adUseClient;
		_bstr_t squery = "select id, Name, Address, Phone, EMail, WebSite, Manager,";
		squery += "DEVELOPERCOL, DEVELOPERDEF,GROUPCOL,GROUPDEF,CODECOL,CODECOL2,CODECOL3,CODECOL4,CODEDEF,NAMECOL,";
		squery += "NAMEDEF,MODELCOL,MODELDEF,PRICECOL,PRICE2COL, PRICE3COL, PRICE4COL, ORIGINALCOL, CURRENCYCOL,CURRENCYDEF,";
		squery += "EXISTCOL,EXISTDEF,LASTFILE,LISTNUM,ROWNUM,PRICEDIR, PRIMARYPRICE, PERCENT2, PERCENT3, PERCENT4 ";
		squery += " from providers where id = ";
		_variant_t vid = _variant_t(m_iID);
		vid.ChangeType(VT_BSTR);
		squery += vid.bstrVal;
		m_pRec->Open(squery, _variant_t((IDispatch *)m_pCon,true), adOpenForwardOnly, adLockOptimistic, adCmdUnspecified);
		if (!m_bEdit) 
			m_pRec->AddNew();
	}
	catch (_com_error const &e)
    {
		CString sm = e.ErrorMessage();
		sm += " "; sm += (LPCSTR)e.Description();
		MessageBox(sm, e.Source(), MB_OK);
		EndDialog(IDCANCEL);
    }
}

BOOL CProviderDlg::CheckValues()
{
	CString s = "";
	m_Name.GetWindowText(s);
	if (s.GetLength()<=0) 
	{
		MessageBox("   ", " ", MB_OK);
		m_Name.SetFocus();
		return FALSE;
	}
	return TRUE;
}

BOOL CProviderDlg::ApplyChanges()
{
	CString s = "";
	VARIANT vNULL; vNULL.vt = VT_NULL;
//   
	m_Name.GetWindowText(s);
	m_pRec->Fields->GetItem(_bstr_t("Name"))->put_Value(_variant_t(_bstr_t((LPCSTR)s)));

	m_Address.GetWindowText(s);
	if (s.GetLength()>0)
		m_pRec->Fields->GetItem(_bstr_t("Address"))->put_Value(_variant_t(_bstr_t((LPCSTR)s)));
	else
		m_pRec->Fields->GetItem(_bstr_t("Address"))->put_Value(vNULL);
	m_Phone.GetWindowText(s);
	if (s.GetLength()>0)
		m_pRec->Fields->GetItem(_bstr_t("Phone"))->put_Value(_variant_t(_bstr_t((LPCSTR)s)));
	else
		m_pRec->Fields->GetItem(_bstr_t("Phone"))->put_Value(vNULL);
	m_EMail.GetWindowText(s);
	if (s.GetLength()>0)
		m_pRec->Fields->GetItem(_bstr_t("EMail"))->put_Value(_variant_t(_bstr_t((LPCSTR)s)));
	else
		m_pRec->Fields->GetItem(_bstr_t("EMail"))->put_Value(vNULL);
	m_WebSite.GetWindowText(s);
	if (s.GetLength()>0)
		m_pRec->Fields->GetItem(_bstr_t("WebSite"))->put_Value(_variant_t(_bstr_t((LPCSTR)s)));
	else
		m_pRec->Fields->GetItem(_bstr_t("WebSite"))->put_Value(vNULL);
	m_Manager.GetWindowText(s);
	if (s.GetLength()>0)
		m_pRec->Fields->GetItem(_bstr_t("Manager"))->put_Value(_variant_t(_bstr_t((LPCSTR)s)));
	else
		m_pRec->Fields->GetItem(_bstr_t("Manager"))->put_Value(vNULL);
	m_PriceDir.GetWindowText(s);
	if (s.GetLength()>0)
		m_pRec->Fields->GetItem(_bstr_t("PRICEDIR"))->put_Value(_variant_t(_bstr_t((LPCSTR)s)));
	else
		m_pRec->Fields->GetItem(_bstr_t("PRICEDIR"))->put_Value(vNULL);
//
	m_LISTNUM.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("LISTNUM"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("LISTNUM"))->put_Value(_variant_t((long)0));
	m_ROWNUM.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("ROWNUM"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("ROWNUM"))->put_Value(_variant_t((long)0));

	m_DEVELOPERCOL.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("DEVELOPERCOL"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("DEVELOPERCOL"))->put_Value(vNULL);
	m_DEVELOPERDEF.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		m_pRec->Fields->GetItem(_bstr_t("DEVELOPERDEF"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("DEVELOPERDEF"))->put_Value(vNULL);

	m_GROUPCOL.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("GROUPCOL"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("GROUPCOL"))->put_Value(vNULL);
	m_GROUPDEF.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		m_pRec->Fields->GetItem(_bstr_t("GROUPDEF"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("GROUPDEF"))->put_Value(vNULL);

	m_CODECOL.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("CODECOL"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("CODECOL"))->put_Value(vNULL);
	m_CODECOL2.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("CODECOL2"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("CODECOL2"))->put_Value(vNULL);
	m_CODECOL3.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("CODECOL3"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("CODECOL3"))->put_Value(vNULL);
	m_CODECOL4.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("CODECOL4"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("CODECOL4"))->put_Value(vNULL);
	m_CODEDEF.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		m_pRec->Fields->GetItem(_bstr_t("CODEDEF"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("CODEDEF"))->put_Value(vNULL);

	m_NAMECOL.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("NAMECOL"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("NAMECOL"))->put_Value(vNULL);
	m_NAMEDEF.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		m_pRec->Fields->GetItem(_bstr_t("NAMEDEF"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("NAMEDEF"))->put_Value(vNULL);

	m_MODELCOL.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("MODELCOL"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("MODELCOL"))->put_Value(vNULL);
	m_MODELDEF.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		m_pRec->Fields->GetItem(_bstr_t("MODELDEF"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("MODELDEF"))->put_Value(vNULL);

	m_PRICECOL.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("PRICECOL"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("PRICECOL"))->put_Value(vNULL);

	m_PRICE2COL.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("PRICE2COL"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("PRICE2COL"))->put_Value(vNULL);

	m_PRICE3COL.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("PRICE3COL"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("PRICE3COL"))->put_Value(vNULL);

	m_PRICE4COL.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("PRICE4COL"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("PRICE4COL"))->put_Value(vNULL);

	m_PERCENT2.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("PERCENT2"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("PERCENT2"))->put_Value(vNULL);

	m_PERCENT3.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("PERCENT3"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("PERCENT3"))->put_Value(vNULL);

	m_PERCENT4.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("PERCENT4"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("PERCENT4"))->put_Value(vNULL);

	m_ORIGINALCOL.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("ORIGINALCOL"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("ORIGINALCOL"))->put_Value(vNULL);

	m_CURRENCYCOL.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("CURRENCYCOL"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("CURRENCYCOL"))->put_Value(vNULL);
	long cursel = m_CURRENCYDEF.GetCurSel();
	m_pRec->Fields->GetItem(_bstr_t("CURRENCYDEF"))->put_Value(_variant_t((long)cursel));

	m_EXISTCOL.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		v.ChangeType(VT_I4);
		m_pRec->Fields->GetItem(_bstr_t("EXISTCOL"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("EXISTCOL"))->put_Value(vNULL);
	m_EXISTDEF.GetWindowText(s);
	if (s.GetLength()>0)
	{
		_variant_t v = _bstr_t(s);
		m_pRec->Fields->GetItem(_bstr_t("EXISTDEF"))->put_Value(v);
	}
	else
		m_pRec->Fields->GetItem(_bstr_t("EXISTDEF"))->put_Value(vNULL);

	long lPrimary = 1;

	if (m_PRIMARY2.GetCheck()==BST_CHECKED)
		lPrimary = 2;
	else if (m_PRIMARY3.GetCheck()==BST_CHECKED)
		lPrimary = 3;
	else if (m_PRIMARY4.GetCheck()==BST_CHECKED)
		lPrimary = 4;
	m_pRec->Fields->GetItem(_bstr_t("PRIMARYPRICE"))->put_Value(_variant_t(lPrimary));

	try { m_pRec->Update(); m_bEdit = TRUE; }
	catch (_com_error &e) { MessageBox(e.Description(), e.Source() , MB_OK); return FALSE;}
	VARIANT vVal;
	m_pRec->Fields->GetItem(_bstr_t("id"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t vid(vVal);
		vid.ChangeType(VT_I4);
		m_iID = vid.lVal;
	}
	return TRUE;
}

LRESULT CProviderDlg::OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	m_bInit = TRUE;
	OpenRecordsets();
	m_Options = GetDlgItem(IDC_IMPORTOPTIONS);
	if (m_bView)
		::EnableWindow(GetDlgItem(IDOK), FALSE);
	if (m_bSelect)
	{
		::SetWindowText(GetDlgItem(IDOK),"");
		m_Options.ShowWindow(SW_SHOW);
	}
	else
		m_Options.ShowWindow(SW_HIDE);
	m_Options.AddString("  -     ");
	m_Options.AddString("  -     ");
	m_Options.SetCurSel(1);

	m_STATIC_NAME.SubclassWindow(GetDlgItem(IDC_STATIC_NAME));
	m_STATIC_IMPORTHEAD.SubclassWindow(GetDlgItem(IDC_STATIC_IMPORTHEAD));

	m_Name.SubclassWindow(GetDlgItem(IDC_NAME));
    m_Address.SubclassWindow(GetDlgItem(IDC_ADDRESS));
    m_Phone.SubclassWindow(GetDlgItem(IDC_PHONE));
    m_EMail.SubclassWindow(GetDlgItem(IDC_EMAIL));
    m_WebSite.SubclassWindow(GetDlgItem(IDC_WEBSITE));
    m_Manager.SubclassWindow(GetDlgItem(IDC_MANAGER));

	m_PriceDir = GetDlgItem(IDC_PRICEDIR);

	m_LISTNUM = GetDlgItem(IDC_LISTNUM);
	m_ROWNUM = GetDlgItem(IDC_ROWNUM);
	m_DEVELOPERCOL = GetDlgItem(IDC_DEVELOPERCOL);
	m_DEVELOPERDEF = GetDlgItem(IDC_DEVELOPERDEF);
	m_GROUPCOL = GetDlgItem(IDC_GROUPCOL);
	m_GROUPDEF = GetDlgItem(IDC_GROUPDEF);
	m_CODECOL = GetDlgItem(IDC_CODECOL);
	m_CODECOL2 = GetDlgItem(IDC_CODECOL2);
	m_CODECOL3 = GetDlgItem(IDC_CODECOL3);
	m_CODECOL4 = GetDlgItem(IDC_CODECOL4);
	m_CODEDEF = GetDlgItem(IDC_CODEDEF);
	m_NAMECOL = GetDlgItem(IDC_NAMECOL);
	m_NAMEDEF = GetDlgItem(IDC_NAMEDEF);
	m_MODELCOL = GetDlgItem(IDC_MODELCOL);
	m_MODELDEF = GetDlgItem(IDC_MODELDEF);
	m_PRICECOL = GetDlgItem(IDC_PRICECOL);
	m_PRICE2COL = GetDlgItem(IDC_PRICE2COL);
	m_PRICE3COL = GetDlgItem(IDC_PRICE3COL);
	m_PRICE4COL = GetDlgItem(IDC_PRICE4COL);
	m_CURRENCYCOL = GetDlgItem(IDC_CURRENCYCOL);
	m_ORIGINALCOL = GetDlgItem(IDC_ORIGINALCOL);
	m_EXISTCOL = GetDlgItem(IDC_EXISTCOL);
	m_EXISTDEF = GetDlgItem(IDC_EXISTDEF);
	m_LASTFILE = GetDlgItem(IDC_LASTFILE);

	m_PRIMARY1 = GetDlgItem(IDC_PRIMARY1);
	m_PRIMARY2 = GetDlgItem(IDC_PRIMARY2);
	m_PRIMARY3 = GetDlgItem(IDC_PRIMARY3);
	m_PRIMARY4 = GetDlgItem(IDC_PRIMARY4);
	m_PRIMARY1.SetCheck(BST_CHECKED);

	m_PERCENT2 = GetDlgItem(IDC_PERCENT2);
	m_PERCENT3 = GetDlgItem(IDC_PERCENT3);
	m_PERCENT4 = GetDlgItem(IDC_PERCENT4);

	m_LISTNUM.SetWindowText("1");
	m_ROWNUM.SetWindowText("1");
	
	m_CURRENCYDEF = GetDlgItem(IDC_CURRENCYDEF); //combo
	m_CURRENCYDEF.AddString("EUR");
	m_CURRENCYDEF.AddString("USD");
	m_CURRENCYDEF.AddString("");
	m_CURRENCYDEF.SetCurSel(0);

	VARIANT vVal;
	m_pRec->Fields->GetItem(_bstr_t("Name"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		m_Name.SetWindowText((LPCSTR)_bstr_t(vVal.bstrVal));
	m_pRec->Fields->GetItem(_bstr_t("Address"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		m_Address.SetWindowText((LPCSTR)_bstr_t(vVal.bstrVal));
	m_pRec->Fields->GetItem(_bstr_t("Phone"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		m_Phone.SetWindowText((LPCSTR)_bstr_t(vVal.bstrVal));
	m_pRec->Fields->GetItem(_bstr_t("EMail"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		m_EMail.SetWindowText((LPCSTR)_bstr_t(vVal.bstrVal));
	m_pRec->Fields->GetItem(_bstr_t("WebSite"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		m_WebSite.SetWindowText((LPCSTR)_bstr_t(vVal.bstrVal));
	m_pRec->Fields->GetItem(_bstr_t("Manager"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		m_Manager.SetWindowText((LPCSTR)_bstr_t(vVal.bstrVal));
	m_pRec->Fields->GetItem(_bstr_t("PRICEDIR"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		m_PriceDir.SetWindowText((LPCSTR)_bstr_t(vVal.bstrVal));

	m_pRec->Fields->GetItem(_bstr_t("LISTNUM"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_LISTNUM.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}
	m_pRec->Fields->GetItem(_bstr_t("ROWNUM"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_ROWNUM.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}
	
	m_pRec->Fields->GetItem(_bstr_t("DEVELOPERCOL"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_DEVELOPERCOL.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}
	m_pRec->Fields->GetItem(_bstr_t("DEVELOPERDEF"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		m_DEVELOPERDEF.SetWindowText((LPCSTR)_bstr_t(vVal.bstrVal));

	m_pRec->Fields->GetItem(_bstr_t("GROUPCOL"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_GROUPCOL.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}
	m_pRec->Fields->GetItem(_bstr_t("GROUPDEF"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		m_GROUPDEF.SetWindowText((LPCSTR)_bstr_t(vVal.bstrVal));

	m_pRec->Fields->GetItem(_bstr_t("CODECOL"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_CODECOL.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}
	m_pRec->Fields->GetItem(_bstr_t("CODECOL2"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_CODECOL2.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}
	m_pRec->Fields->GetItem(_bstr_t("CODECOL3"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_CODECOL3.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}
	m_pRec->Fields->GetItem(_bstr_t("CODECOL4"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_CODECOL4.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}
	m_pRec->Fields->GetItem(_bstr_t("CODEDEF"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		m_CODEDEF.SetWindowText((LPCSTR)_bstr_t(vVal.bstrVal));

	m_pRec->Fields->GetItem(_bstr_t("NAMECOL"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_NAMECOL.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}
	m_pRec->Fields->GetItem(_bstr_t("NAMEDEF"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		m_NAMEDEF.SetWindowText((LPCSTR)_bstr_t(vVal.bstrVal));

	m_pRec->Fields->GetItem(_bstr_t("MODELCOL"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_MODELCOL.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}
	m_pRec->Fields->GetItem(_bstr_t("MODELDEF"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		m_MODELDEF.SetWindowText((LPCSTR)_bstr_t(vVal.bstrVal));

	m_pRec->Fields->GetItem(_bstr_t("PRICECOL"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_PRICECOL.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}

	m_pRec->Fields->GetItem(_bstr_t("PRICE2COL"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_PRICE2COL.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}

	m_pRec->Fields->GetItem(_bstr_t("PRICE3COL"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_PRICE3COL.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}
	m_pRec->Fields->GetItem(_bstr_t("PRICE4COL"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_PRICE4COL.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}

	m_pRec->Fields->GetItem(_bstr_t("PERCENT2"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_PERCENT2.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}

	m_pRec->Fields->GetItem(_bstr_t("PERCENT3"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_PERCENT3.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}

	m_pRec->Fields->GetItem(_bstr_t("PERCENT4"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_PERCENT4.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}

	m_pRec->Fields->GetItem(_bstr_t("ORIGINALCOL"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_ORIGINALCOL.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}

	m_pRec->Fields->GetItem(_bstr_t("CURRENCYCOL"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_CURRENCYCOL.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}
	m_pRec->Fields->GetItem(_bstr_t("CURRENCYDEF"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_I4);
		m_CURRENCYDEF.SetCurSel(v.lVal);
	}

	m_pRec->Fields->GetItem(_bstr_t("EXISTCOL"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		_variant_t v = vVal;
		v.ChangeType(VT_BSTR);
		m_EXISTCOL.SetWindowText((LPCSTR)_bstr_t(v.bstrVal));
	}
	m_pRec->Fields->GetItem(_bstr_t("EXISTDEF"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		m_EXISTDEF.SetWindowText((LPCSTR)_bstr_t(vVal.bstrVal));

	m_pRec->Fields->GetItem(_bstr_t("LASTFILE"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
		m_LASTFILE.SetWindowText((LPCSTR)_bstr_t(vVal.bstrVal));

	m_pRec->Fields->GetItem(_bstr_t("PRIMARYPRICE"))->get_Value(&vVal);
	if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
	{
		m_PRIMARY1.SetCheck(BST_UNCHECKED);
		_variant_t v = vVal;
		v.ChangeType(VT_I4);
		if (v.lVal==2)
			m_PRIMARY2.SetCheck(BST_CHECKED);
		else if (v.lVal==3)
			m_PRIMARY3.SetCheck(BST_CHECKED);
		else if (v.lVal==4)
			m_PRIMARY4.SetCheck(BST_CHECKED);
		else
			m_PRIMARY1.SetCheck(BST_CHECKED);
	}

	SetWindowText(m_sCaption);
	CenterWindow(::GetDesktopWindow());
//	RECT rc, rc1;
//	::GetWindowRect(GetParent(), &rc);
//	GetWindowRect(&rc1);
//	MoveWindow(rc1.left, rc.top, rc1.right - rc1.left, rc1.bottom - rc1.top);
	m_bInit = FALSE;
	return TRUE;
}

LRESULT CProviderDlg::OnOk(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	if (CheckValues())
	{
		if (ApplyChanges())
		{
			char ch[9]; ch[8] = '\0';
			::GetWindowText(GetDlgItem(IDOK), ch, 7);
			if (strcmp("", ch)==0)
			{
				CImportFromExcel imp;
				VARIANT vVal;
				m_pRec->Fields->GetItem(_bstr_t("id"))->get_Value(&vVal);
				if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
				{
					imp.m_iID = vVal.lVal;
					if (m_sLastFile.GetLength()>0)
					{
						imp.m_sFileName = m_sLastFile;
						imp.m_pCon = m_pCon;
						imp.m_bSave = (BOOL)m_Options.GetCurSel();
						imp.StartImport();
					}
				}
			}
			m_pRec->Close();
			EndDialog(wID);
		}
		else
			return 0;
	}
	return 0;
}

LRESULT CProviderDlg::OnClose(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
//	if (MessageBox("C ?", "", MB_OKCANCEL) == IDOK)
//	{
//		if (CheckValues())
//		{
//			if (ApplyChanges())
//				EndDialog(IDOK);
//			else
//				return 0;
//		}
//	}	
//	else
		EndDialog(IDCANCEL);
	return 0;
}

LRESULT CProviderDlg::OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	EndDialog(IDCANCEL);
	return 0;
}

LRESULT CProviderDlg::OnBnClickedButton1(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CFolderDialog dlg(NULL, "       ");
	if (dlg.DoModal()==IDOK)
		m_PriceDir.SetWindowText(dlg.m_szFolderPath);
	return 0;
}
