// ProviderList.cpp : implementation of the CListDlg class
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include ".\ProviderList.h"
#include ".\ProviderDlg.h"
#include ".\importfromexcel.h"

CProviderList::CProviderList()
{
	m_sSelect = "";
	m_sCondition = "";
	m_sCaption="";
	m_pCon = NULL;
	m_pRec = NULL;
	m_bSelect=TRUE;
	m_iID=0;
	m_bInit = TRUE;
	m_sFont = "MS Sans Serif";
	m_lSize = 9;
	fnt = 0;
	m_sLastFile = "";
}

void CProviderList::Find()
{
	CString s = "";
	m_Combo.GetWindowText(s);
	if (s.GetLength()<=0) 
	{ 
		MessageBox("    ", "", MB_OK);
		m_Combo.SetFocus();
		return; 
	}
	else 
		if (-1 != m_List.Find(s))
			if ((0>m_Combo.FindString(0, s)) && (m_Combo.GetCount()<20)) m_Combo.AddString(s);
}

LRESULT CProviderList::OnRefresh(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	Reload();
	return 0;
}

void CProviderList::Add()
{
	CProviderDlg dlg;
	dlg.m_pCon = m_pCon;
	dlg.m_bEdit = FALSE;
	dlg.m_bSelect = m_bSelect;
	if (!m_bSelect)
		dlg.m_sCaption = " ";
	else
	{
		dlg.m_sCaption = m_sCaption;
		dlg.m_sLastFile = m_sLastFile;
	}
	if (dlg.DoModal()==IDOK) 
	{
		m_pRec->Requery(adCmdUnspecified);
		m_List.RefreshRecord(dlg.m_iID, m_pRec);
		m_List.SelectItem(m_List.FindItem(dlg.m_iID));
	}
}
void CProviderList::Edit()
{
	if (m_List.GetItemCount()<=0) {MessageBox("    ", " ", MB_OK); return;}
	int iItem = m_List.GetSelectedIndex(); 
	if (iItem>=0)
	{
		CProviderDlg dlg;
		dlg.m_pCon = m_pCon;
		dlg.m_bEdit = TRUE;
		dlg.m_bSelect = m_bSelect;
		dlg.m_iID = m_List.GetItemData(iItem);
		if (!m_bSelect)
			dlg.m_sCaption = " : ";
		else
		{
			dlg.m_sCaption = m_sCaption;
			dlg.m_sLastFile = m_sLastFile;
		}
		if (dlg.DoModal()==IDOK) 
		{
			m_pRec->Requery(adCmdUnspecified);
			m_List.RefreshRecord(dlg.m_iID, m_pRec);
			m_List.SelectItem(iItem);
		}
	}
}
void CProviderList::Delete()
{
	if (m_List.GetItemCount()<=0) {MessageBox("    "," ",MB_OK); return;}
	int iItem = m_List.GetSelectedIndex(); 
	if (iItem>=0)
	{
		if (MessageBox("     .  ?"," ",MB_OKCANCEL)==IDOK)
		{
			long dwi = m_List.GetItemData(iItem);
			_variant_t vv(dwi);
			vv.ChangeType(VT_BSTR);
			CComBSTR qr("delete from providers where id =");
			qr.AppendBSTR(vv.bstrVal);
			try{ m_pCon->Execute(qr.m_str, NULL, adExecuteNoRecords);}
			catch (_com_error &e) { MessageBox(e.Description(), e.Source() , MB_OK); return;}
			m_pRec->Requery(adCmdUnspecified);
			m_List.DeleteItem(iItem);
			m_List.SelectItem(iItem-1);
			return;
		}
	}
}

LRESULT CProviderList::OnAsc(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_List.Sort(TRUE);
	m_List.RefreshData(m_pRec);
	return 0;
}
LRESULT CProviderList::OnDesc(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_List.Sort(FALSE);
	m_List.RefreshData(m_pRec);
	return 0;
}
LRESULT CProviderList::OnAdd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	Add();
	m_List.SetFocus();
	return 0;
}
LRESULT CProviderList::OnEdit(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	Edit();
	m_List.SetFocus();
	return 0;
}
LRESULT CProviderList::OnDelete(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	Delete();
	m_List.SetFocus();
	return 0;
}

LRESULT CProviderList::OnFilter(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_List.SetFocus();
	return 0;
}

LRESULT CProviderList::OnRclickList(int idCtrl, LPNMHDR pnmh, BOOL& bHandled)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pnmh);
	m_List.m_iCol = pNMLV->iSubItem;
	CMenuHandle menu = LoadMenu(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_EDIT));
	CMenuHandle submenu = menu.GetSubMenu(0);
	LPNMITEMACTIVATE	pItemActivate = (LPNMITEMACTIVATE)pnmh;
	POINT pt = pItemActivate->ptAction; 
    ::ClientToScreen(m_List.m_hWnd, &pt);
	m_CmdBar.TrackPopupMenu(submenu, TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y);
	return 0;
}

LRESULT CProviderList::OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_List.SaveOrderArray();
	DeleteObject(fnt);
	EndDialog(wID);
	return 0;
}

LRESULT CProviderList::OnOk(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	if (m_List.GetItemCount()<=0) {MessageBox("    ", " ", MB_OK); return 0;}
	int iItem = m_List.GetSelectedIndex(); 
	if (iItem>=0)
	{
		m_iID = m_List.GetItemData(iItem);
		m_List.SaveOrderArray();
		char ch[9]; ch[8] = '\0';
		::GetWindowText(GetDlgItem(IDOK), ch, 7);
		if (strcmp("", ch)==0)
		{
			CImportFromExcel imp;
			imp.m_iID = m_iID;
			if (m_sLastFile.GetLength()>0)
			{
				imp.m_sFileName = m_sLastFile;
				imp.m_pCon = m_pCon;
				imp.StartImport();
			}
		}
		EndDialog(wID);
	}	
	return 0;
}

LRESULT CProviderList::OnDblclkList(int idCtrl, LPNMHDR pnmh, BOOL& bHandled)
{
	if (m_List.GetItemCount()<=0) 
	{
		MessageBox("    ", "", MB_OK); 
		return 0;
	}
	int iItem = m_List.GetSelectedIndex(); 
	if (iItem>=0)
		Edit();
	else
	{
		MessageBox("    ", "", MB_OK); 
		return 0;
	}
	return 0;
}

void CProviderList::SetFont()
{
	if (fnt!=0)
	{
		fnt.Detach();
		DeleteObject(fnt);
	}
	fnt = NULL;
	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT));
	CClientDC dc(m_hWnd);
	lf.lfHeight = -MulDiv(m_lSize, GetDeviceCaps(dc.m_hDC, LOGPIXELSY), 72);;                      
#ifdef UNICODE
	wcscpy(lf.lfFaceName, m_sFont); 
#else
	strcpy(lf.lfFaceName, m_sFont); 
#endif
	lf.lfCharSet = RUSSIAN_CHARSET;
	fnt.CreateFontIndirect(&lf);
	m_List.SetFont(fnt);
}

void CProviderList::InitList()
{
	m_List.SubclassWindow(GetDlgItem(IDC_LIST), "ProviderList");
	m_List.AddCol(CString(""), 0, 150);
	m_List.AddCol(CString(""), 1, 300);
	m_List.AddCol(CString(" ()"), 2, 150);
	m_List.AddCol(CString("E-Mail"), 3, 150);
	m_List.AddCol(CString(""), 4, 100);
	m_List.AddCol(CString(""), 5, 100);
	m_List.AddCol(CString(" "), 6, 100);
	m_List.SetOrder();
	SetFont();
}

void CProviderList::Reload()
{
	try
	{
		CComBSTR qr((LPCSTR)m_sSelect);
		if (m_sCondition.GetLength()>0)
			qr.Append((LPCSTR)m_sCondition);
		if (m_pRec == NULL)
			CoCreateInstance(__uuidof(Recordset), NULL, CLSCTX_ALL, __uuidof(_Recordset), (void**)&m_pRec);
		else
			m_pRec->Close();
		m_pRec->CursorLocation = adUseClient;
		m_pRec->Open(qr.m_str, _variant_t((IDispatch *)m_pCon,true), adOpenForwardOnly, adLockOptimistic, adCmdUnspecified);
		m_List.RefreshData(m_pRec);
	}
	catch( _com_error &e)
	{
		CString msg = "  : ";
		msg += (LPCSTR)e.Description();
		CString stitle = " :";
		stitle += (LPCSTR)e.Source();
		MessageBox(msg , stitle , MB_OK);
	}
	m_List.SetFocus();
}

BOOL CProviderList::PreTranslateMessage(MSG* pMsg)
{
	return IsDialogMessage(pMsg);
}

LRESULT CProviderList::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	m_Ok = GetDlgItem(IDOK);
	SetWindowText(m_sCaption);
	if (!m_bSelect)
	{
		m_Ok.ShowWindow(SW_HIDE);
		::SetWindowText(GetDlgItem(IDCANCEL), "");
	}
	else
		m_Ok.SetWindowText("");
	InitList();
	m_sSelect = "select id, Name, Address, Phone, EMail, WebSite, Manager, LASTFILE from providers";
	Reload();
	m_bInit = FALSE;
	m_List.SelectItem(m_List.FindItem(m_iID));
	
	m_CmdBar.Create(m_hWnd, rcDefault, NULL, ATL_SIMPLE_CMDBAR_PANE_STYLE);
	m_CmdBar.LoadImages(IDR_MAINIMAGES);
	RECT rcClient;
	GetClientRect(&rcClient);
	m_ctrlToolbar.SubclassWindow( CFrameWindowImplBase<>::CreateSimpleToolBarCtrl(m_hWnd, IDR_EDIT, FALSE, ATL_SIMPLE_TOOLBAR_STYLE | CCS_NODIVIDER | CCS_NOPARENTALIGN | TBSTYLE_LIST | TBSTYLE_FLAT) );
	m_ctrlToolbar.MoveWindow(0,0, rcClient.right - rcClient.left, 10);
	m_ctrlToolbar.AutoSize();	
	m_ctrlToolbar.ModifyStyle(0, CCS_ADJUSTABLE);
	AddButtonText(m_ctrlToolbar, ID_REFRESH, IDS_REFRESH);
	AddButtonText(m_ctrlToolbar, ID_ADD, IDS_ADD);
	AddButtonText(m_ctrlToolbar, ID_EDIT, IDS_EDIT);
	AddButtonText(m_ctrlToolbar, ID_DELETE, IDS_DELETE);
	AddButtonText(m_ctrlToolbar, ID_FIND, IDS_FIND);
	RECT rcCombo = { 410, 1, 600, 100 }; 
	DWORD dwStyle = WS_CHILD | WS_BORDER | WS_VISIBLE | CBS_DROPDOWN;
	m_Combo.Create(m_hWnd, rcCombo, _T(""), dwStyle);
	m_Combo.SetFont(AtlGetDefaultGuiFont());
	m_Combo.SetParent(m_ctrlToolbar);
	m_Combo.m_hMainWnd = m_hWnd;	
	DlgResize_Init(false, true, WS_CLIPCHILDREN);
	CenterWindow(::GetDesktopWindow());

	if ((m_bSelect) && (m_sLastFile.GetLength()>0))
		m_List.Find(m_sLastFile);
//	RECT rc, rc1;
//	::GetWindowRect(GetParent(), &rc);
//	GetWindowRect(&rc1);
//	MoveWindow(rc1.left, rc.top, rc1.right - rc1.left, rc1.bottom - rc1.top);
	return TRUE;
}

LRESULT CProviderList::OnLvnKeydownList(int /*idCtrl*/, LPNMHDR pNMHDR, BOOL& /*bHandled*/)
{
	LPNMLVKEYDOWN pLVKeyDow = reinterpret_cast<LPNMLVKEYDOWN>(pNMHDR);
	switch (pLVKeyDow->wVKey)
	{
		case VK_SPACE : 
		{ Edit(); 	m_List.SetFocus();}
		break;
		case VK_INSERT : 
		{Add(); m_List.SetFocus();} 
		break;
		case VK_DELETE : 
		{ Delete(); m_List.SetFocus(); } 
		break;
		case 'F' : ::SetFocus(m_Combo); break;
		case 'A' : ::SetFocus(m_Combo); break;
		case VK_F3 : Find(); break;
	}
	return 0;
}

