// ProviderList.h : interface of the CLICView class
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include "resource.h"

class CProviderList : 
	public CDialogImpl<CProviderList>,
	public CDialogResize<CProviderList>
{
public:
	CProviderList();
	CString m_sSelect;
	CString m_sCondition;
	CString m_sCaption;

	_ConnectionPtr m_pCon;
    _RecordsetPtr  m_pRec;

	HWND m_parent;

	CString m_sFont;
	long m_lSize;
	CFont fnt;

	BOOL m_bSelect;
	long m_iID;

	CString m_sLastFile;

	BOOL m_bInit;

	enum { IDD = IDD_LISTDLG };

	CToolBarXPCtrl m_ctrlToolbar;
	CCommandBarXPCtrl m_CmdBar;
	CSortListCtrl m_List;
	CButton m_Ok;
	CComboBoxXPCtrl m_Combo;

	BOOL PreTranslateMessage(MSG* pMsg);

	BEGIN_MSG_MAP(CProviderList)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		COMMAND_ID_HANDLER(IDOK, OnOk)
		COMMAND_ID_HANDLER(IDCANCEL, OnCloseCmd)
		COMMAND_ID_HANDLER(ID_REFRESH, OnRefresh)
		COMMAND_ID_HANDLER(ID_ASC, OnAsc)
		COMMAND_ID_HANDLER(ID_DESC, OnDesc)
		COMMAND_ID_HANDLER(ID_ADD, OnAdd)
		COMMAND_ID_HANDLER(ID_EDIT, OnEdit)
		COMMAND_ID_HANDLER(ID_DELETE, OnDelete)
		COMMAND_ID_HANDLER(ID_FIND, OnFind)
		COMMAND_ID_HANDLER(IDC_BUTTON1, OnFind)
		CHAIN_MSG_MAP( CDialogResize<CProviderList> )
		NOTIFY_HANDLER(IDC_LIST, LVN_KEYDOWN, OnLvnKeydownList)
		NOTIFY_HANDLER(IDC_LIST, NM_RCLICK, OnRclickList)
		NOTIFY_HANDLER(IDC_LIST, NM_DBLCLK, OnDblclkList)
		REFLECT_NOTIFICATIONS()
	END_MSG_MAP()

	BEGIN_DLGRESIZE_MAP(CProviderList)
		DLGRESIZE_CONTROL(IDC_LIST, DLSZ_SIZE_X | DLSZ_SIZE_Y)
		DLGRESIZE_CONTROL(IDCANCEL, DLSZ_MOVE_X | DLSZ_MOVE_Y)
		DLGRESIZE_CONTROL(IDOK, DLSZ_MOVE_X | DLSZ_MOVE_Y)
	END_DLGRESIZE_MAP()

// Handler prototypes (uncomment arguments if needed):
//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/)
	void InitList();
	void Reload();
	void Add();
	void Edit();
	void Delete();
	void Find();
	void SetFont();

	LRESULT OnRefresh(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnAsc(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnDesc(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnAdd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnEdit(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnDelete(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnFilter(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnFind(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/){Find(); return 0;}
		
	LRESULT OnRclickList(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);
	LRESULT OnLvnKeydownList(int /*idCtrl*/, LPNMHDR pNMHDR, BOOL& /*bHandled*/);
	LRESULT OnDblclkList(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnOk(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
};
