// stdafx.cpp : source file that includes just the standard includes
//	Price.pch will be the pre-compiled header
//	stdafx.obj will contain the pre-compiled type information

#include "stdafx.h"

#if (_ATL_VER < 0x0700)
#include <atlimpl.cpp>
#endif //(_ATL_VER < 0x0700)

#ifdef _ATL_STATIC_REGISTRY
#include <statreg.h>
#if (_ATL_VER < 0x0700)
#include <statreg.cpp>
#endif //(_ATL_VER < 0x0700)
#endif //_ATL_STATIC_REGISTRY

void AddButtonText(CToolBarCtrl tb, UINT nID, UINT nRes)
{
	TBBUTTONINFO tbi = { 0 };
	tbi.cbSize = sizeof(TBBUTTONINFO),
	tbi.dwMask  = TBIF_STYLE;
	tb.GetButtonInfo(nID, &tbi);
	tbi.dwMask = TBIF_STYLE | TBIF_TEXT;
	tbi.fsStyle |= TBSTYLE_TOOLTIPS | BTNS_SHOWTEXT | TBSTYLE_AUTOSIZE ;
	CString s(MAKEINTRESOURCE(nRes));
	tbi.pszText = (LPTSTR) (LPCTSTR) s;
	tb.SetButtonInfo(nID, &tbi);
}

BOOL InitToolBar(HWND hWndToolBar, UINT nResource, BOOL bInitialSeparator)
{
	CSimpleArray<TBBUTTON> aButtons;
   
	ATLASSERT(::IsWindow(hWndToolBar));

    // The ToolBar is adjustable!
    CToolBarCtrl tb = hWndToolBar;
    tb.ModifyStyle(0, CCS_ADJUSTABLE);

    // Gather information about toolbar buttons by building the toolbar.
    // Needed so we can reset it later on.
    // This code is almost identical to the CFrameWindowImplBase::CreateSimpleToolBarCtrl
    // code, but it also needs to build it the exact same way...
    HINSTANCE hInst = _Module.GetResourceInstance();
    HRSRC hRsrc = ::FindResource(hInst, (LPCTSTR) nResource, RT_TOOLBAR);
    if (hRsrc == NULL) return FALSE;
    HGLOBAL hGlobal = ::LoadResource(hInst, hRsrc);
    if( hGlobal == NULL ) return FALSE;

    struct _AtlToolBarData
    {
        WORD wVersion;
        WORD wWidth;
        WORD wHeight;
        WORD wItemCount;
        //WORD aItems[wItemCount]
        WORD* items() { return (WORD*)(this+1); }
    };
    _AtlToolBarData* pData = (_AtlToolBarData*) ::LockResource(hGlobal);
    if( pData==NULL ) return FALSE;
    ATLASSERT(pData->wVersion==1);

    WORD* pItems = pData->items();
    // Set initial separator (half width)
    if( bInitialSeparator ) {
        TBBUTTON bt;
        bt.iBitmap = 4;
        bt.idCommand = 0;
        bt.fsState = 0;
        bt.fsStyle = TBSTYLE_SEP;
        bt.dwData = 0;
        bt.iString = 0;
        aButtons.Add(bt);
    }
    // Scan other buttons
    int nBmp = 0;
    for( int i=0, j= bInitialSeparator ? 1 : 0; i<pData->wItemCount; i++, j++ ) {
        if( pItems[i] != 0 ) {
        TBBUTTON bt;
        bt.iBitmap = nBmp++;
        bt.idCommand = pItems[i];
        bt.fsState = TBSTATE_ENABLED;
        bt.fsStyle = TBSTYLE_BUTTON;
        bt.dwData = 0;
        bt.iString = 0;
        aButtons.Add(bt);
        }
        else {
        TBBUTTON bt;
        bt.iBitmap = 8;
        bt.idCommand = 0;
        bt.fsState = 0;
        bt.fsStyle = TBSTYLE_SEP;
        bt.dwData = 0;
        bt.iString = 0;
        aButtons.Add(bt);
        }
    }
    return TRUE;
}
