#pragma once


class CDataControl  
{
public:
	~CDataControl()	{ Destroy();}
	void Destroy()	{ m_CtrlArray.RemoveAll(); }
private:
	struct CCtrl
	{
		CCtrl()
		{
			m_iCtrlType = 0;
			m_nID = 0;
			m_bNotNull = FALSE;
			m_pTarget = NULL;
			m_pSource = NULL;
			m_iEditVal = -1;
			m_sFieldName = "";
		}
		~CCtrl()
		{
		}
		int m_iCtrlType; // 0 - edit, 1 - combo, 2 - check, 3 readonly edit
		UINT m_nID; //ID 
		BOOL m_bNotNull; //   NULL
		_RecordsetPtr m_pTarget; //   
		_RecordsetPtr m_pSource; //   .   combo
		int m_iEditVal; //  edit   ;
		CColoredComboBoxCtrlNN m_comboNN;
		CColoredComboBoxCtrl m_combo;
		CColoredEditCtrlNN m_editNN;
		CColoredEditCtrl m_edit;
		CButton m_button; //check box
		CString m_sFieldName; //   m_pTarget
	};	
	CCtrl m_Item;
	CSimpleArray<CCtrl> m_CtrlArray;
public:
	HWND m_hDlg;
	void AddCheckBox(UINT nID, _RecordsetPtr pTarget, CString& sFieldName, BOOL bNotNull = FALSE)
	{
		m_Item.m_iCtrlType = 2;
		m_Item.m_bNotNull = bNotNull;
		m_Item.m_pTarget = pTarget;
		m_Item.m_button = GetDlgItem(m_hDlg, nID);
		m_Item.m_nID = nID;
		m_Item.m_sFieldName = sFieldName;
		m_CtrlArray.Add(m_Item);
	}

	BOOL CheckValues()
	{
		int isize = m_CtrlArray.GetSize();
		if (isize>0)
		{
			for (int i=0; i<isize; i++)
			{
				if (m_CtrlArray[i].m_iCtrlType == 0) 
					if (m_CtrlArray[i].m_editNN.Check() == FALSE) return FALSE;
				if (m_CtrlArray[i].m_iCtrlType == 1) 
					if (m_CtrlArray[i].m_comboNN.Check() == FALSE) return FALSE;
			}
		}
		return TRUE;
	}
	void RefreshCombo()
	{
		int isize = m_CtrlArray.GetSize();
		if (isize>0)
		{
			for (int i=0; i<isize; i++)
			{
				if (m_CtrlArray[i].m_iCtrlType == 1)
				{
					if (m_CtrlArray[i].m_bNotNull)
						while (m_CtrlArray[i].m_comboNN.GetCount()>0)
							m_CtrlArray[i].m_comboNN.DeleteString(0);
					else
						while (m_CtrlArray[i].m_combo.GetCount()>0)
							m_CtrlArray[i].m_combo.DeleteString(0);
					if (m_CtrlArray[i].m_pSource != NULL)
					{
						if (m_CtrlArray[i].m_pSource->RecordCount > 0) 
						{
							m_CtrlArray[i].m_pSource->MoveFirst();
							while (m_CtrlArray[i].m_pSource->EndOfFile==VARIANT_FALSE)
							{
								VARIANT vVal;
								m_CtrlArray[i].m_pSource->Fields->GetItem((long)1)->get_Value(&vVal); //   (0)  id
								if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
								{
									if (m_CtrlArray[i].m_bNotNull)
										m_CtrlArray[i].m_comboNN.AddString(CString((char*)_bstr_t(vVal.bstrVal)));
									else
										m_CtrlArray[i].m_comboNN.AddString(CString((char*)_bstr_t(vVal.bstrVal)));
								}
								m_CtrlArray[i].m_pSource->MoveNext();
							}
						}
					}
				}
			}
		}
	}
	void AddEdit(UINT nID, _RecordsetPtr pTarget, CString& sFieldName, BOOL bNotNull = FALSE)
	{
		m_Item.m_iCtrlType = 0;
		m_Item.m_bNotNull = bNotNull;
		m_Item.m_pTarget = pTarget;
		m_Item.m_nID = nID;
		m_Item.m_sFieldName = sFieldName;
		if (m_Item.m_bNotNull)
			m_Item.m_editNN.SubclassWindow(GetDlgItem(m_hDlg, nID));
		else
			m_Item.m_edit.SubclassWindow(GetDlgItem(m_hDlg, nID));
		m_CtrlArray.Add(m_Item);
	}
	int GetIntEdit(UINT nID)
	{
		int isize = m_CtrlArray.GetSize();
		if (isize>0)
		{
			for (int i=0; i<isize; i++)
			{
				if (m_CtrlArray[i].m_nID == nID)
					return m_CtrlArray[i].m_iEditVal;
			}
		}
		return -1;
	}
	void SetIntEdit(UINT nID, int iVal)
	{
		int isize = m_CtrlArray.GetSize();
		if (isize>0)
		{
			for (int i=0; i<isize; i++)
			{
				if (m_CtrlArray[i].m_nID == nID)
				{
					m_CtrlArray[i].m_iEditVal = iVal;
					return;
				}
			}
		}
	}
	void ApplyChanges()
	{
		int isize = m_CtrlArray.GetSize();
		if (isize>0)
		{
			for (int i=0; i<isize; i++)
			{
				if (m_CtrlArray[i].m_iCtrlType < 2) // edit  combo
				{
					if ((m_CtrlArray[i].m_pTarget != NULL) && (m_CtrlArray[i].m_pSource!=NULL))
					{
						if ((m_CtrlArray[i].m_pTarget->RecordCount > 0) && (m_CtrlArray[i].m_pSource->RecordCount > 0)) 
						{
							if (m_CtrlArray[i].m_sFieldName.GetLength()>0)
							{
								if (m_CtrlArray[i].m_iCtrlType == 0)
								{
									char ch[256]; ch[255] = '\0';
									if (m_CtrlArray[i].m_bNotNull == TRUE)
										m_CtrlArray[i].m_editNN.GetWindowText(ch, 255);
									else
										m_CtrlArray[i].m_edit.GetWindowText(ch, 255);
									if (strlen(ch)>0)
										m_CtrlArray[i].m_pTarget->Fields->GetItem(_bstr_t(LPCSTR(m_CtrlArray[i].m_sFieldName)))->put_Value(_variant_t(_bstr_t(ch))); 
								}									
								if (m_CtrlArray[i].m_iCtrlType == 1)
								{
									char ch[256]; ch[255] = '\0';
									if (m_CtrlArray[i].m_bNotNull == TRUE)
										m_CtrlArray[i].m_comboNN.GetWindowText(ch, 255);
									else
										m_CtrlArray[i].m_combo.GetWindowText(ch, 255);
									_variant_t lval;
//----------------------------------------------------------------------
									m_CtrlArray[i].m_pSource->MoveFirst();
									while (m_CtrlArray[i].m_pSource->EndOfFile==VARIANT_FALSE)
									{
										VARIANT vVal;
										m_CtrlArray[i].m_pSource->Fields->GetItem((long)1)->get_Value(&vVal); //   (0)  id
										if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
										{
											if (strcmp(ch, (LPCSTR)_bstr_t(vVal.bstrVal))==0)
											{
												m_CtrlArray[i].m_pSource->Fields->GetItem((long)1)->get_Value(&lval);
												break;
											}
										}
										m_Item.m_pSource->MoveNext();
									}
//----------------------------------------------------------------------
									if ((lval.vt != VT_EMPTY) && (lval.vt != VT_ERROR) && (lval.vt != VT_NULL)) 
										m_CtrlArray[i].m_pTarget->Fields->GetItem(_bstr_t(LPCSTR(m_CtrlArray[i].m_sFieldName)))->put_Value(lval); 
								}									
							}
						}
					}
				}
				if (m_CtrlArray[i].m_iCtrlType == 3)//readonly edit
				{
					if ((m_CtrlArray[i].m_pTarget != NULL) && (m_CtrlArray[i].m_pSource!=NULL))
					{
						if ((m_CtrlArray[i].m_pTarget->RecordCount > 0) && (m_CtrlArray[i].m_pSource->RecordCount > 0)) 
						{
							if (m_CtrlArray[i].m_sFieldName.GetLength()>0)
								m_CtrlArray[i].m_pTarget->Fields->GetItem(_bstr_t(LPCSTR(m_CtrlArray[i].m_sFieldName)))->put_Value(_variant_t((long)m_CtrlArray[i].m_iEditVal)); 
						}
					}
				}
				if (m_CtrlArray[i].m_iCtrlType == 2)//check
				{
					if ((m_CtrlArray[i].m_pTarget != NULL) && (m_CtrlArray[i].m_pSource!=NULL))
					{
						if ((m_CtrlArray[i].m_pTarget->RecordCount > 0) && (m_CtrlArray[i].m_pSource->RecordCount > 0)) 
						{
							if (m_CtrlArray[i].m_sFieldName.GetLength()>0)
							{
								if (m_CtrlArray[i].m_button.GetCheck())
									m_CtrlArray[i].m_pTarget->Fields->GetItem(_bstr_t(LPCSTR(m_CtrlArray[i].m_sFieldName)))->put_Value(_variant_t(VARIANT_TRUE)); 
								else
									m_CtrlArray[i].m_pTarget->Fields->GetItem(_bstr_t(LPCSTR(m_CtrlArray[i].m_sFieldName)))->put_Value(_variant_t(VARIANT_FALSE)); 
							}
						}
					}
				}
			}
		}
	}
	void FillControls()
	{
		int isize = m_CtrlArray.GetSize();
		if (isize>0)
		{
			for (int i=0; i<isize; i++)
			{
				if (m_CtrlArray[i].m_iCtrlType < 2) // edit  combo
				{
					if (m_CtrlArray[i].m_pTarget != NULL)
					{
						if (m_CtrlArray[i].m_pTarget->RecordCount > 0) 
						{
							if (m_CtrlArray[i].m_sFieldName.GetLength()>0)
							{
								VARIANT vVal;
								m_CtrlArray[i].m_pTarget->Fields->GetItem(_bstr_t(LPCSTR(m_CtrlArray[i].m_sFieldName)))->get_Value(&vVal); 
								if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
								{
									if (m_CtrlArray[i].m_iCtrlType == 0)
									{
										if (m_CtrlArray[i].m_bNotNull == TRUE)
											m_CtrlArray[i].m_editNN.SetWindowText(CString((char*)_bstr_t(vVal.bstrVal)));
										else
											m_CtrlArray[i].m_edit.SetWindowText(CString((char*)_bstr_t(vVal.bstrVal)));
									}									
									if (m_CtrlArray[i].m_iCtrlType == 1)
									{
										if (m_CtrlArray[i].m_bNotNull == TRUE)
											m_CtrlArray[i].m_comboNN.SetWindowText(CString((char*)_bstr_t(vVal.bstrVal)));
										else
											m_CtrlArray[i].m_combo.SetWindowText(CString((char*)_bstr_t(vVal.bstrVal)));
									}									
								}
							}
						}
					}
				}
				if (m_CtrlArray[i].m_iCtrlType == 3)//readonly edit
				{
					if (m_CtrlArray[i].m_pTarget != NULL)
					{
						if (m_CtrlArray[i].m_pTarget->RecordCount > 0) 
						{
							if (m_CtrlArray[i].m_sFieldName.GetLength()>0)
							{
								VARIANT vVal;
								m_CtrlArray[i].m_pTarget->Fields->GetItem(_bstr_t(LPCSTR(m_CtrlArray[i].m_sFieldName)))->get_Value(&vVal); 
								if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
								{
									_variant_t vv(vVal);
									vv.ChangeType(VT_UI4);
									m_CtrlArray[i].m_iEditVal = (int)vv.ulVal;
								}
							}
						}
					}
				}
				if (m_CtrlArray[i].m_iCtrlType == 2)//check
				{
					if (m_CtrlArray[i].m_pTarget != NULL)
					{
						if (m_CtrlArray[i].m_pTarget->RecordCount > 0) 
						{
							if (m_CtrlArray[i].m_sFieldName.GetLength()>0)
							{
								VARIANT vVal;
								m_CtrlArray[i].m_pTarget->Fields->GetItem(_bstr_t(LPCSTR(m_CtrlArray[i].m_sFieldName)))->get_Value(&vVal); 
								if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
								{
									_variant_t vv(vVal);
									vv.ChangeType(VT_BOOL);
									if (vv.boolVal == VARIANT_TRUE)
										m_CtrlArray[i].m_button.SetCheck(TRUE);
									else
										m_CtrlArray[i].m_button.SetCheck(FALSE);
								}
								else
									m_CtrlArray[i].m_button.SetCheck(FALSE);
							}
						}
					}
				}
			}
		}
	}
	void AddIntEdit(UINT nID, _RecordsetPtr pTarget, int iVal, CString& sFieldName, BOOL bNotNull = FALSE)
	{
		m_Item.m_iCtrlType = 0;
		m_Item.m_bNotNull = bNotNull;
		m_Item.m_pTarget = pTarget;
		m_Item.m_nID = nID;
		m_Item.m_iEditVal = iVal;
		m_Item.m_sFieldName = sFieldName;
		if (m_Item.m_bNotNull)
			m_Item.m_editNN.SubclassWindow(GetDlgItem(m_hDlg, nID));
		else
			m_Item.m_edit.SubclassWindow(GetDlgItem(m_hDlg, nID));
		m_CtrlArray.Add(m_Item);
	}
	void AddComboBox(UINT nID, _RecordsetPtr pTarget, CString& sFieldName, _RecordsetPtr pSource = NULL, BOOL bNotNull = FALSE)
	{
		m_Item.m_iCtrlType = 1;
		m_Item.m_bNotNull = bNotNull;
		m_Item.m_pTarget = pTarget;
		m_Item.m_pSource = pSource;
		m_Item.m_nID = nID;
		m_Item.m_sFieldName = sFieldName;
		if (m_Item.m_bNotNull)
			m_Item.m_comboNN.SubclassWindow(GetDlgItem(m_hDlg, nID));
		else
			m_Item.m_combo.SubclassWindow(GetDlgItem(m_hDlg, nID));
		if (m_Item.m_pSource->RecordCount > 0) 
		{
			m_Item.m_pSource->MoveFirst();
			while (m_Item.m_pSource->EndOfFile==VARIANT_FALSE)
			{
				VARIANT vVal;
				m_Item.m_pSource->Fields->GetItem((long)1)->get_Value(&vVal); //   (0)  id
				if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
				{
					if (m_Item.m_bNotNull)
						m_Item.m_comboNN.AddString(CString((char*)_bstr_t(vVal.bstrVal)));
					else
						m_Item.m_comboNN.AddString(CString((char*)_bstr_t(vVal.bstrVal)));
				}
				m_Item.m_pSource->MoveNext();
			}
		}
		m_CtrlArray.Add(m_Item);
	}

};