// DateTimeCtrV.h: interface for the CDateTimeCtrV class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DATETIMECTRLV_H__823C4E6F_CCCB_4AE1_A719_8F832ACF0208__INCLUDED_)
#define AFX_DATETIMECTRLV_H__823C4E6F_CCCB_4AE1_A719_8F832ACF0208__INCLUDED_

#pragma once

class CDateTimePickerCtrlV : public CDateTimePickerCtrl
{
public:
	CDateTimePickerCtrlV(HWND hWnd = NULL) : CDateTimePickerCtrl(hWnd) 
	{
	}
	CDateTimePickerCtrlV& operator=(HWND hWnd)
	{
		m_hWnd = hWnd;
		SetEnabled(TRUE);
		return *this;
	}
	void SetEnabled(BOOL bEnabled)
	{
		if (::IsWindow(m_hWnd))
		{
			if (bEnabled)
				::SendMessage(m_hWnd, DTM_SETSYSTEMTIME, GDT_VALID, 0);
			else
				::SendMessage(m_hWnd, DTM_SETSYSTEMTIME, GDT_NONE, 0);
		}
	}
	void SetDate(VARIANT vDate)
	{
		if ((vDate.vt != VT_EMPTY) && (vDate.vt != VT_ERROR) && (vDate.vt != VT_NULL)) 
		{
			SYSTEMTIME st; 
			_variant_t vd(vDate);
			try {vd.ChangeType(VT_DATE);} catch (...) {SetEnabled(FALSE); return;}
			VariantTimeToSystemTime(vd.date, &st);
			SetSystemTime(0, &st);
		}
		else SetEnabled(FALSE);
	}
	void GetDate(VARIANT &vDate)
	{
		SYSTEMTIME st; 
		if (GetSystemTime(&st) == GDT_VALID)
		{
			double d;
			SystemTimeToVariantTime(&st, &d);
			_variant_t vd(d); 
			vd.ChangeType(VT_DATE);
			vDate = vd;
		}
		else
			vDate.vt = VT_NULL;
	}
}; 

#endif 