// SortListCtrl.h: interface for the CSortListCtrl class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SORTLISTCTRL_H__823C4E6F_CCCB_4AE1_A719_8F832ACF0208__INCLUDED_)
#define AFX_SORTLISTCTRL_H__823C4E6F_CCCB_4AE1_A719_8F832ACF0208__INCLUDED_

#pragma once

//bool IsDate( LPCTSTR pszText );
//bool IsNumber( LPCTSTR pszText );
//int DateCompare( const CString& strDate1, const CString& strDate2 );
//int NumberCompare( LPCTSTR pszNumber1, LPCTSTR pszNumber2 );
//int CALLBACK CompareFunction( LPARAM lParam1, LPARAM lParam2, LPARAM lParamData );

template<class T, class TBase = CListViewCtrl, class TWinTraits = CControlWinTraits>
class ATL_NO_VTABLE CSortListViewImpl : public CWindowImpl<T, TBase, TWinTraits>
{
public:
	int m_iCol;
	BOOL m_bSortAscending;

	DECLARE_WND_SUPERCLASS(NULL,CListViewCtrl::GetWndClassName() );
	BEGIN_MSG_MAP(CSortListViewImpl)
		DEFAULT_REFLECTION_HANDLER()
  	END_MSG_MAP()
public:
/*	static int CALLBACK CompareFunction( LPARAM lParam1, LPARAM lParam2, LPARAM lParamData )
	{
		CSortListCtrl* pListCtrl = reinterpret_cast<CSortListCtrl*>( lParamData );
		char ch[256]; ch[255]='\0';
		pListCtrl->GetItemText(lParam1, pListCtrl->m_iCol, ch, 255);
		CString    strItem1 = ch;
		pListCtrl->GetItemText(lParam2, pListCtrl->m_iCol, ch, 255);
		CString    strItem2 = ch;
		if( IsNumber( strItem1 ) )
			return pListCtrl->m_bSortAscending ? NumberCompare( strItem1, strItem2 ) : NumberCompare( strItem2, strItem1 );
		else if( IsDate( strItem1 ) )
			return pListCtrl->m_bSortAscending ? DateCompare( strItem1, strItem2  ) : DateCompare( strItem2, strItem1 );
		else
			return pListCtrl->m_bSortAscending ? lstrcmp( strItem1, strItem2  ) : lstrcmp( strItem2, strItem1 );

	}
*/
	CString m_sControlName;
	LPINT m_lpOrder;
	LPINT m_lpColWidht;
	long m_lSelectedItem;
	int m_iExistCol;

	CSortListViewImpl()
	{
		m_lpOrder = NULL;
		m_lpColWidht = NULL;
		m_iExistCol = -1;
	}

	~CSortListViewImpl()
	{
		if (m_lpOrder != NULL) free(m_lpOrder);
		if (m_lpColWidht != NULL) free(m_lpColWidht);
	}
	void SubclassWindow(HWND hWnd, CString sControlName = "")
	{
		ATLASSERT(m_hWnd == NULL);
		ATLASSERT(::IsWindow(hWnd));
		CWindowImpl< T, CListViewCtrl, TWinTraits >::SubclassWindow(hWnd);
		SetExtendedListViewStyle(LVS_EX_FULLROWSELECT | LVS_EX_HEADERDRAGDROP | LVS_EX_GRIDLINES ); //| LVS_EX_CHECKBOXES | LVS_EX_FLATSB  
		m_sControlName = sControlName;
		m_lpOrder = NULL;
		m_lpColWidht = NULL;
		LoadOrderArray();
	}

	void AddCol(CString& sName, int iSubItem, int iWidht = 100)
	{
		LVCOLUMN	column;
		column.mask		= LVCF_FMT | LVCF_TEXT | LVCF_WIDTH;
		column.fmt		= LVCFMT_LEFT;
		column.pszText	= (LPSTR)sName.GetString();
		column.iSubItem	= iSubItem;
		if (m_lpColWidht != NULL)
			try { column.cx = m_lpColWidht[iSubItem]; } catch (...) {column.cx = iWidht;}
		else
			column.cx = iWidht;
		InsertColumn(iSubItem, &column);
		if (sName == "")
			m_iExistCol = iSubItem+1;
	}
	void SetOrder()
	{
		if (m_lpOrder)
		{
			CHeaderCtrl headerCtrl = GetHeader();
			int nCount = headerCtrl.GetItemCount();
			SetColumnOrderArray(nCount, m_lpOrder);
		}
	}
	void Sort(BOOL bAscending)
	{
		if (m_iCol<0) m_iCol = 0;
		m_bSortAscending = bAscending;
		int iSelectedItem = GetSelectedIndex();
		if (iSelectedItem>=0)
			m_lSelectedItem = GetItemData(iSelectedItem);
//		SortItems( CompareFunction, reinterpret_cast<DWORD>(this));
	}
	void SaveOrderArray()
	{
		CHeaderCtrl headerCtrl = GetHeader();
		int nCount = headerCtrl.GetItemCount();
		if (nCount<=0) return;
		m_lpOrder = (LPINT) malloc(sizeof(int)*nCount);
		headerCtrl.GetOrderArray(nCount, m_lpOrder);
		m_lpColWidht = (LPINT) malloc(sizeof(int)*nCount);
		for (int i=0; i<nCount; i++)
			m_lpColWidht[i] = GetColumnWidth(i);
		HKEY hRegKey;
		HKEY hTempKey1;
		HKEY hTempKey2;
		DWORD dwDisposition; 
		::RegCreateKeyEx (HKEY_LOCAL_MACHINE, "Software", NULL, NULL, REG_OPTION_NON_VOLATILE, KEY_READ, NULL, &hTempKey1, &dwDisposition);
		::RegCreateKeyEx (hTempKey1, "Auto", NULL, NULL, REG_OPTION_NON_VOLATILE, KEY_READ|KEY_WRITE, NULL, &hTempKey2, &dwDisposition);
		::RegCreateKeyEx (hTempKey2, "Price", NULL, NULL, REG_OPTION_NON_VOLATILE, KEY_READ|KEY_WRITE, NULL, &hRegKey, &dwDisposition);
		::RegCloseKey(hTempKey1);
		::RegCloseKey(hTempKey2);
		DWORD lpType = REG_BINARY;
		if (m_lpOrder != NULL) 
			::RegSetValueEx(hRegKey, (LPCSTR)(m_sControlName+"Order"), NULL, lpType, (BYTE*)m_lpOrder, sizeof(int)*nCount);
		else
			::RegSetValueEx(hRegKey, (LPCSTR)(m_sControlName+"Order"), NULL, lpType, (BYTE*)NULL, 0);
		if (m_lpColWidht != NULL) 
			::RegSetValueEx(hRegKey, (LPCSTR)(m_sControlName+"ColWidht"), NULL, lpType, (BYTE*)m_lpColWidht, sizeof(int)*nCount);
		else
			::RegSetValueEx(hRegKey, (LPCSTR)(m_sControlName+"ColWidht"), NULL, lpType, (BYTE*)NULL, 0);
  		::RegCloseKey(hRegKey);
	}
	void LoadOrderArray()
	{
		HKEY hRegKey;
		HKEY hTempKey1;
		HKEY hTempKey2;
		if (ERROR_SUCCESS!=	::RegOpenKeyEx (HKEY_LOCAL_MACHINE, "Software", NULL, KEY_READ|KEY_WRITE, &hTempKey1))
			return;
		if (ERROR_SUCCESS!=	::RegOpenKeyEx (hTempKey1, "Auto", NULL, KEY_READ|KEY_WRITE, &hTempKey2))
		{
			::RegCloseKey(hTempKey1);
			return;
		}
		if (ERROR_SUCCESS!=	::RegOpenKeyEx (hTempKey2, "Price", NULL, KEY_READ|KEY_WRITE, &hRegKey))
		{
			::RegCloseKey(hTempKey1);
			::RegCloseKey(hTempKey2);
			return;
		}
		::RegCloseKey(hTempKey1);
		::RegCloseKey(hTempKey2);
		DWORD dwTempSize = NULL;
		DWORD lpType = REG_BINARY; 
		::RegQueryValueEx(hRegKey, (LPCSTR)(m_sControlName+"Order"), NULL, &lpType, NULL, &dwTempSize);
		if (m_lpOrder!=NULL) { free(m_lpOrder); m_lpOrder = NULL; }
		if (dwTempSize)
		{
			m_lpOrder = (LPINT)malloc(dwTempSize);
			::RegQueryValueEx(hRegKey, (LPCSTR)(m_sControlName+"Order"), NULL, &lpType, (LPBYTE)m_lpOrder, &dwTempSize);
		}	
		dwTempSize = NULL;
		::RegQueryValueEx(hRegKey, (LPCSTR)(m_sControlName+"ColWidht"), NULL, &lpType, NULL, &dwTempSize);
		if (m_lpColWidht!=NULL) { free(m_lpColWidht); m_lpColWidht = NULL; }
		if (dwTempSize)
		{
			m_lpColWidht = (LPINT)malloc(dwTempSize);
			::RegQueryValueEx(hRegKey, (LPCSTR)(m_sControlName+"ColWidht"), NULL, &lpType, (LPBYTE)m_lpColWidht, &dwTempSize);
		}	
		::RegCloseKey(hRegKey);
	}
	int Find(CString& sName)
	{
		int itc = GetItemCount();
		if (itc<=0) return -1;
		if (sName.GetLength()<=0) return -1;
		int iItem = GetSelectedIndex() + 1; 
		if ((iItem < 0) || (iItem > itc-1)) iItem = 0;
		CHeaderCtrl headerCtrl = GetHeader();
		int ic, nCount = headerCtrl.GetItemCount();
		HDITEM hdi;
		TCHAR  lpBuffer[256];
		bool   fFound = false;
		hdi.mask = HDI_TEXT;
		hdi.pszText = lpBuffer;
		hdi.cchTextMax = 256;
		int is = 0;
		for (iItem; iItem < itc; iItem++)
		{
			for (ic=0; ic < nCount; ic++)
			{
				char ch[256]; ch[255]='\0';
				GetItemText(iItem, ic, ch, 255);
				CString s = ch;
				if (s.GetLength()>= sName.GetLength())
				{
					if (s.MakeUpper().Find(sName.MakeUpper())>=0)
					{
						SelectItem(iItem);
						SetFocus();
						return iItem;
					}
				}
			}
			if ((iItem == itc-1) && (is == 0))
			{
				is = 1;
				iItem = -1;
			}
		}
//		SetFocus();
		return -1;
	}

	int FindItem(long lData)
	{
		int i = GetItemCount();
		if (i<=0) return -1;
		for (int ii=0; ii<i; ii++)
		{
			if (lData == GetItemData(ii)) return ii;
		}
		return -1;
	}
	void RefreshRecord(long lID, _RecordsetPtr  pRec)
	{
		if (pRec->RecordCount <= 0) { DeleteAllItems(); return; }
		pRec->MoveFirst();
		while (pRec->EndOfFile==VARIANT_FALSE)
		{
			VARIANT vVal;
			pRec->Fields->GetItem((long)0)->get_Value(&vVal);
			_variant_t vv(vVal);
			vv.ChangeType(VT_I4);
			if (lID == vv.lVal)
			{
				int iItem = FindItem(lID);
				if (iItem<0) iItem = InsertItem(GetItemCount(), "", 0);
				CHeaderCtrl head = GetHeader();
				int iCol = head.GetItemCount()+1;
				if (iCol > pRec->Fields->Count) iCol = pRec->Fields->Count;
				SetItemData(iItem, lID);
				for (long i = 1; i < iCol; i++)
				{
					pRec->Fields->GetItem(i)->get_Value(&vVal);
					if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
					{
						vv = _variant_t(vVal);
						vv.ChangeType(VT_BSTR);
						SetItemText(iItem, i-1, CString((LPCSTR)_bstr_t(vv.bstrVal)));
					}
				}
				return;
			}
			pRec->MoveNext();
		}
		DeleteItem(FindItem(lID));
	}
	void RefreshData(_RecordsetPtr  pRec)
	{
		if ((m_iCol < 0) || (m_iCol > pRec->Fields->GetCount())) m_iCol = 0;
		if (m_bSortAscending < 0) m_bSortAscending = TRUE;
//		_variant_t vi((long)m_iCol+1); vi.ChangeType(VT_BSTR);		
//		_variant_t vf(pRec->Fields->GetCount()); vf.ChangeType(VT_BSTR);		
//		MessageBox((LPCSTR)_bstr_t(vi.bstrVal), (LPCSTR)_bstr_t(vf.bstrVal));
		CString sSort = (LPCSTR)pRec->Fields->GetItem((long)m_iCol+1)->GetName();
		if (m_bSortAscending) sSort += " ASC";
		else sSort += " DESC";
		pRec->PutSort(_bstr_t((LPCSTR)sSort));
		CHeaderCtrl head = GetHeader();
		int iCol = head.GetItemCount()+1;
		int iselecteditem = GetSelectedIndex();
		if (iselecteditem>=0)
			m_lSelectedItem = GetItemData(iselecteditem);
		if ((pRec->RecordCount <= 0) || ((GetItemCount()-pRec->RecordCount)>100)) { DeleteAllItems(); }
		if (pRec->RecordCount <= 0) return;
		//SetItemCount(pRec->RecordCount);
		while (pRec->RecordCount > GetItemCount())
			InsertItem(GetItemCount(), "", 1);
		while (pRec->RecordCount < GetItemCount())
			DeleteItem(GetItemCount()-1);
		pRec->MoveFirst();
		int iItem = 0;
		while (pRec->EndOfFile==VARIANT_FALSE)
		{
			VARIANT vVal;
			if (iCol > pRec->Fields->Count) iCol = pRec->Fields->Count;
			long iPrmaryPrice = -1;
			for (long ipp=0; ipp<pRec->Fields->Count; ipp++)
			{
				if (pRec->Fields->GetItem(ipp)->GetName() == _bstr_t("PrimaryPrice"))
				{
					VARIANT vpp;
					pRec->Fields->GetItem(ipp)->get_Value(&vpp);
					if ((vpp.vt != VT_EMPTY) && (vpp.vt != VT_ERROR) && (vpp.vt != VT_NULL)) 
					{
						_variant_t vxpp(vpp);
						vxpp.ChangeType(VT_I4);
						iPrmaryPrice = vxpp.lVal;
					}
					break;
				}
			}
			long iData = 0;
			SetCheckState(iItem, FALSE);
			for (long i = 0; i < iCol; i++)
			{
				pRec->Fields->GetItem(i)->get_Value(&vVal);
				if (i==0)
				{
					_variant_t vv(vVal);
					vv.ChangeType(VT_UI4);
					iData = vv.ulVal;
					SetItemData(iItem, iData);
				}
				else
				{
					CString s = "";
					if ((m_iExistCol>0)&&(m_iExistCol==i))
					{
						LVITEM	item = { 0 };
						item.mask = LVIF_IMAGE;
						item.iItem	= iItem;
						item.iSubItem = 0;
						if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
						{
							_variant_t vx (vVal);
							vx.ChangeType(VT_BSTR);
							CString sx = (LPCSTR)_bstr_t(vx.bstrVal);
							if (sx.Find("-",0)>=0)
								item.iImage = 1;
							else
								item.iImage	= 0;
						}
						else
							item.iImage = 1;
						SetItem(&item);
					}
					if (iPrmaryPrice>0)
					{
	                    CString sn = (LPCSTR)pRec->Fields->GetItem(i)->GetName();
						sn.MakeUpper();
						bool bp = false;
						if ((sn == "PRICE")&&(iPrmaryPrice==1))
							bp = true;
						else if ((sn == "PRICE2")&&(iPrmaryPrice==2))
							bp = true;
						else if ((sn == "PRICE3")&&(iPrmaryPrice==3))
							bp = true;
						else if ((sn == "PRICE4")&&(iPrmaryPrice==4))
							bp = true;
						LVITEM	item = { 0 };
						item.mask = LVIF_IMAGE;
						item.iItem	= iItem;
						item.iSubItem = i-1;
						if (bp)
							item.iImage = 2;
						else
							item.iImage = -1;
						SetItem(&item);
					}
					if ((vVal.vt != VT_EMPTY) && (vVal.vt != VT_ERROR) && (vVal.vt != VT_NULL)) 
					{
						_variant_t vv (vVal);
						vv.ChangeType(VT_BSTR);
						s = (LPCSTR)_bstr_t(vv.bstrVal);
						SetItemText(iItem, i-1, s);
					}
					else
						SetItemText(iItem, i-1, CString(""));
					//Update(iItem);
				}
			}
			iItem++;
			pRec->MoveNext();
		}
		int iSelectedItem = FindItem(m_lSelectedItem);
		if (iSelectedItem<0) iSelectedItem = 0;
		SelectItem(iSelectedItem);
	}
};

class CSortListCtrl : public CSortListViewImpl<CSortListCtrl>
{
public:
   DECLARE_WND_CLASS(_T("WTL_SortListView"))
};



#endif // !defined(AFX_TREELISTCTRL_H__823C4E6F_CCCB_4AE1_A719_8F832ACF0208__INCLUDED_)
