// WarnMsg.h : interface of the CMainDlg class
//
/////////////////////////////////////////////////////////////////////////////

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "BalloonTip.h"
#include "Office97Buttons.h"
#include "resource.h"

class CWarnMsg : public CDialogImpl<CWarnMsg>, public CBalloonDialog<CWarnMsg>
{
public:
   CWarnMsg()
   {
		m_sCaption = "  ";
		m_sMessage = "";
   }
   enum { IDD = IDD_DLGTIP };
   
   CString m_sCaption;
   CString m_sMessage;

   CStatic m_Caption;
   CStatic m_Message;
   CFont m_fontTitle;
   CImageList m_images;
   
   COfficeButtonCtrl m_ctrlOK;
   //COfficeButtonCtrl m_ctrlCancel;

   BEGIN_MSG_MAP(CWarnMsg)
      MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
      COMMAND_ID_HANDLER(IDOK, OnOK)
      COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
      if( lParam==(LPARAM)(HWND)m_Caption) MESSAGE_HANDLER(WM_CTLCOLORSTATIC, OnWhiteLabelCtlColorStatic)
      CHAIN_MSG_MAP( CBalloonDialog<CWarnMsg> )
      REFLECT_NOTIFICATIONS()
   ALT_MSG_MAP(1)
      CHAIN_MSG_MAP_ALT( CBalloonDialog<CWarnMsg>, 1 )
   END_MSG_MAP()

   LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
   {
      HFONT hFont = GetFont();
      LOGFONT lf;
      ::GetObject(hFont, sizeof(LOGFONT), &lf);
      lf.lfHeight -= 5;
      lf.lfWeight = FW_BOLD;
      m_fontTitle.CreateFontIndirect(&lf),

      m_images.Create(IDB_OFFICE97, 10, 1, RGB(255,0,255));

      m_Caption = GetDlgItem(IDC_CAPTION);
      m_Caption.SetFont(m_fontTitle);
	  ::SetWindowText(m_Caption, m_sCaption);
	  m_Message = GetDlgItem(IDC_MESSAGE);
      m_Message.SetFont(m_fontTitle);
	  ::SetWindowText(m_Message, m_sMessage);

      m_ctrlOK.SubclassWindow(GetDlgItem(IDOK));
      m_ctrlOK.SetImageList(m_images);
      m_ctrlOK.SetImages(3,0,2,1);
//      m_ctrlCancel.SubclassWindow(GetDlgItem(IDCANCEL));
//      m_ctrlCancel.SetImageList(m_images);
//      m_ctrlCancel.SetImages(3,0,2,1);

      bHandled = FALSE; // CBalloonDialog needs this...
      return 0;
   }
   LRESULT OnWhiteLabelCtlColorStatic(UINT /*uMsg*/, WPARAM wParam, LPARAM /*lParam*/, BOOL& /*bHandled*/)
   {
      CDCHandle dc( (HDC) wParam );
      dc.SetTextColor(RGB(0,0,200));
      dc.SetBkColor(RGB(255,255,255)),
      dc.SetBkMode(TRANSPARENT);
      return (LRESULT) (HBRUSH) ::GetStockObject(WHITE_BRUSH);
   }

   LRESULT OnOK(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
   {
      // TODO: Add validation code 
      EndDialog(wID);
      return 0;
   }
   LRESULT OnCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
   {
      EndDialog(wID);
      return 0;
   }
};
